using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Blu
{
    public partial class Form1 : Form
    {
        bool PrefsEdited = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tabControl1.TabPages.Clear();

            Globals.Load();
            Map.ProgressBar = pb1;
            Map.ProgressLabel = stat;
        }

        private void openMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (o.ShowDialog() == DialogResult.Cancel) return;

            Map.StartProgress(6);
            Map.Load(o.FileName);
            Map.UpdateProgress("Populating list...", 6);

            tabControl1.Focus();
            PrefsEdited = false;

            if (tabControl1.TabPages.Count == 0)
            {
                comboBox1.SelectedIndex = 0;
                tabControl1.TabPages.AddRange(new TabPage[] { tabPage1, tabPage2 });

                dataGridView1.Rows.Add(new object[] { "X Button", Globals.uniTranslations[0] });
                dataGridView1.Rows.Add(new object[] { "Y Button", Globals.uniTranslations[1] });
                dataGridView1.Rows.Add(new object[] { "B Button", Globals.uniTranslations[2] });
                dataGridView1.Rows.Add(new object[] { "Energy Sword", Globals.uniTranslations[3] });
                dataGridView1.Rows.Add(new object[] { "Plasma Rifle", Globals.uniTranslations[4] });
                dataGridView1.Rows.Add(new object[] { "Brute Plasma Rifle", Globals.uniTranslations[5] });
                dataGridView1.Rows.Add(new object[] { "Plasma Pistol", Globals.uniTranslations[6] });
                dataGridView1.Rows.Add(new object[] { "Covenant Carbine", Globals.uniTranslations[7] });
                dataGridView1.Rows.Add(new object[] { "Disintegrator", Globals.uniTranslations[8] });
                dataGridView1.Rows.Add(new object[] { "Beam Rifle", Globals.uniTranslations[9] });
                dataGridView1.Rows.Add(new object[] { "Brute Shot", Globals.uniTranslations[10] });
                dataGridView1.Rows.Add(new object[] { "Fuel Rod Cannon", Globals.uniTranslations[11] });
                dataGridView1.Rows.Add(new object[] { "Battle Rifle", Globals.uniTranslations[12] });
                dataGridView1.Rows.Add(new object[] { "Needler", Globals.uniTranslations[13] });
                dataGridView1.Rows.Add(new object[] { "Magnum", Globals.uniTranslations[14] });
                dataGridView1.Rows.Add(new object[] { "Rocket Launcher", Globals.uniTranslations[15] });
                dataGridView1.Rows.Add(new object[] { "Shotgun", Globals.uniTranslations[16] });
                dataGridView1.Rows.Add(new object[] { "SMG", Globals.uniTranslations[17] });
                dataGridView1.Rows.Add(new object[] { "Sniper Rifle", Globals.uniTranslations[18] });
                dataGridView1.Rows.Add(new object[] { "Sentinel Beam", Globals.uniTranslations[19] });
                dataGridView1.Rows.Add(new object[] { "Sentinel Grenade Launcher", Globals.uniTranslations[20] });
                dataGridView1.Rows.Add(new object[] { "Bomb", Globals.uniTranslations[21] });
                dataGridView1.Rows.Add(new object[] { "Oddball", Globals.uniTranslations[22] });
                dataGridView1.Rows.Add(new object[] { "Flag", Globals.uniTranslations[23] });

                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[24] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[25] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[26] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[27] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[28] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[29] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[30] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[31] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[32] });
                dataGridView1.Rows.Add(new object[] { "", Globals.uniTranslations[33] });

                resignTool.Enabled = true;
            }
            else comboBox1_SelectedIndexChanged(null, null);

            this.Text = "Blu - " + Path.GetFileName(o.FileName);
            Map.EndProgress();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            lv2.Items.Clear();
            rtb3.Text = "";

            Lang lang = Map.unicode.langs[comboBox1.SelectedIndex];
            int len = lang.UniStrings.Length;

            bool bool1 = (Map.ProgressBar.Value == 0);
            if (bool1)
            {
                Map.StartProgress(1);
                Map.UpdateProgress("Populating list...", 1);
            }

            //bool bool1 = false;
            for (int x = 0; x < len; x++)
            {
                ListViewItem lv = lv2.Items.Add(lang.UniStrings[x].uString);
                lv.SubItems.Add(lang.UniStrings[x].Length.ToString());
                lv.SubItems.Add(lang.UniStrings[x].Offset.ToString());

                //if (bool1) lv.BackColor = Color.Gainsboro;
                //bool1 = !bool1;
            }

            if (bool1) Map.EndProgress();
        }

        private void lv2_Resize(object sender, EventArgs e)
        {
            int w = lv2.Width / 5;
            lv2.Columns[0].Width = (w * 3);
            lv2.Columns[1].Width = w - SystemInformation.VerticalScrollBarWidth;
            lv2.Columns[2].Width = w - SystemInformation.VerticalScrollBarWidth;
        }

        private void lv2_SelectedIndexChanged(object sender, EventArgs e)
        {
            rtb3.Text = lv2.FocusedItem == null ? ""
                : lv2.FocusedItem.Text.Replace(@" \r\n ", "\r\n");
        }

        private void textBox9_TextChanged(object sender, EventArgs e)
        {
            lv2.Items.Clear();
            rtb3.Text = "";

            Lang lang = Map.unicode.langs[comboBox1.SelectedIndex];
            int len = lang.UniStrings.Length;

            string txt = textBox9.Text;
            bool bool1 = false;
            for (int x = 0; x < len; x++)
            {
                if (txt != textBox9.Text) return;
                if (lang.UniStrings[x].uString.Contains(txt))
                {
                    ListViewItem lv = lv2.Items.Add(lang.UniStrings[x].uString);
                    lv.SubItems.Add(lang.UniStrings[x].Length.ToString());
                    lv.SubItems.Add(lang.UniStrings[x].Offset.ToString());

                    if (bool1) lv.BackColor = Color.Gainsboro;
                    bool1 = !bool1;
                }
            }
        }

        private void rtb3_TextChanged(object sender, EventArgs e)
        {
            if (rtb3.TextLength == 0) button7.Enabled = false;
            else
            {
                int pos = rtb3.SelectionStart;
                int len = rtb3.SelectionLength;

                RichTextBox tmpBox = new RichTextBox();
                tmpBox.Text = rtb3.Text;

                for (int x = 0; x < Globals.uniTranslations.Length; x++)
                    Highlighter(tmpBox, Globals.uniTranslations[x], 0);

                rtb3.Rtf = tmpBox.Rtf;
                rtb3.SelectionStart = pos;
                rtb3.SelectionLength = len;

                button7.Enabled = true;
                tmpBox.Dispose();
            }
        }

        public void Highlighter(RichTextBox rtb, string txt, int indx)
        {
            int a = rtb.Text.IndexOf(txt, indx);
            if (a != -1)
            {
                rtb.SelectionStart = a;
                rtb.SelectionLength = txt.Length;
                rtb.SelectionBackColor = Color.LightSteelBlue;

                Highlighter(rtb, txt, a + txt.Length);
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Map.StartProgress(1);
            Map.UpdateProgress("Writing Unicode...", 1);

            Lang lang = Map.unicode.langs[comboBox1.SelectedIndex];

            for (int x = 0; x < lv2.SelectedItems.Count; x++)
            {
                Map.unicode.WriteString(comboBox1.SelectedIndex,
                    lv2.SelectedItems[x].Index, rtb3.Text.Replace("\n", "\r\n"));

                lv2.SelectedItems[x].Text = rtb3.Text.Replace("\n", @" \r\n ");
                lv2.SelectedItems[x].SubItems[1].Text = lang.UniStrings[lv2.SelectedItems[x].Index].Length.ToString();
            }

            for (int x = lv2.SelectedItems[0].Index + 1; x < lv2.Items.Count; x++)
                lv2.Items[x].SubItems[2].Text = lang.UniStrings[x].Offset.ToString();

            Map.EndProgress();
        }

        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex != -1)
            {
                Globals.uniTranslations[e.RowIndex] = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
                PrefsEdited = true;
            }
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 0 && PrefsEdited)
            {
                Map.unicode.ReReadStrings();
                comboBox1_SelectedIndexChanged(null, null);
                PrefsEdited = false;
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            //Globals.Save();
        }

        private void resignToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FileStream fs = new FileStream(Map.path,
                FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);

            BinaryReader br = new BinaryReader(fs);
            BinaryWriter bw = new BinaryWriter(fs);

            int sig = 0;
            long length = br.BaseStream.Length;

            br.BaseStream.Position = 2048;

            for (long i = 2048; i < length; i += 4)
                sig ^= br.ReadInt32();

            br.BaseStream.Position = 720;
            bw.Write(sig);

            br.Close();
            bw.Close();

            Map.header.checksum = sig;
            stat.Text = "Done! New Signature is 0x" + sig.ToString("X");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!Directory.Exists(Globals.folder))
                Directory.CreateDirectory(Globals.folder);

            StreamWriter sw = File.CreateText(Globals.folder + "Extract.txt");

            for (int x = 0; x < lv2.Items.Count; x++)
            {
                if (lv2.Items[x].Text.Contains("[? "))
                    sw.WriteLine(lv2.Items[x].Text);
            }
            sw.Close();
        }
    }
}