using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;

namespace Blu
{
    public sealed class Globals
    {
        public static string
        drive = Path.GetPathRoot(Application.StartupPath),
        folder = drive + "Program Files\\Homebrewgames\\Blu\\",
        sav = folder + "Settings.cfg";

        public static short[] uniDwords = new short[34];
        public static string[] uniTranslations = new string[34];

        public static void Load()
        {
            //1
            uniDwords[0] = -30575;
            uniDwords[1] = -30319;
            uniDwords[2] = -30063;
            uniDwords[3] = -24700;
            uniDwords[4] = -24956;
            uniDwords[5] = -21884;
            uniDwords[6] = -25212;
            uniDwords[7] = -27260;
            uniDwords[8] = -23164;
            uniDwords[9] = -23420;
            uniDwords[10] = -27516;
            uniDwords[11] = -26748;
            uniDwords[12] = -28028;
            uniDwords[13] = -25724;
            uniDwords[14] = -25980;
            uniDwords[15] = -24444;
            uniDwords[16] = -24188;
            uniDwords[17] = -23932;
            uniDwords[18] = -23676;
            uniDwords[19] = -22908;
            uniDwords[20] = -22396;
            uniDwords[21] = -27772;
            uniDwords[22] = -25468;
            uniDwords[23] = -27004;

            //2
            uniDwords[24] = -23920;
            uniDwords[25] = -29551;
            uniDwords[26] = -28527;
            uniDwords[27] = -26735;
            uniDwords[28] = -26991;
            uniDwords[29] = -24943;
            uniDwords[30] = -28271;
            uniDwords[31] = -29295;
            uniDwords[32] = -32380;
            uniDwords[33] = -31100;

            if (File.Exists(sav))
            {
                StreamReader sr = File.OpenText(sav);

                for (int x = 0; x < uniTranslations.Length; x++)
                    uniTranslations[x] = sr.ReadLine();

                sr.Close();
            }
            else
            {
                uniTranslations[0] = "(X)";
                uniTranslations[1] = "(Y)";
                uniTranslations[2] = "(B)";
                uniTranslations[3] = "[ES]";
                uniTranslations[4] = "[PR]";
                uniTranslations[5] = "[BPR]";
                uniTranslations[6] = "[PP]";
                uniTranslations[7] = "[CC]";
                uniTranslations[8] = "[D]";
                uniTranslations[9] = "[BeamR]";
                uniTranslations[10] = "[BS]";
                uniTranslations[11] = "[FRC]";
                uniTranslations[12] = "[BR]";
                uniTranslations[13] = "[N]";
                uniTranslations[14] = "[M]";
                uniTranslations[15] = "[RL]";
                uniTranslations[16] = "[S]";
                uniTranslations[17] = "[SMG]";
                uniTranslations[18] = "[SR]";
                uniTranslations[19] = "[SB]";
                uniTranslations[20] = "[SGL]";
                uniTranslations[21] = "[BOMB]";
                uniTranslations[22] = "[ODD]";
                uniTranslations[23] = "[FLAG]";

                //2
                uniTranslations[24] = "[Num]";
                uniTranslations[25] = "(LT)";
                uniTranslations[26] = "(LAS)";
                uniTranslations[27] = "(RAS Up Down)";
                uniTranslations[28] = "(LAS2)";
                uniTranslations[29] = "(LT2)";
                uniTranslations[30] = "(RAS Left Right)"; //?
                uniTranslations[31] = "(RT)";
                uniTranslations[32] = "[BansheeBoost]";
                uniTranslations[33] = "(LT3)";
            }
        }

        public static void Save()
        {
            if (!Directory.Exists(folder))
                Directory.CreateDirectory(folder);

            StreamWriter sw = File.CreateText(sav);

            for (int x = 0; x < uniTranslations.Length; x++)
                sw.WriteLine(uniTranslations[x]);

            sw.Close();
        }
    }
}
