using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Blu
{
    public class Header
    {
        //header info
        public string
        head,
        origin,
        internalName,
        buildDate,
        scenarioName,
        foot;

        public int
        version,
        filesize,

        indexOffset,
        indexSize,

        metaStart,
        metaSize,
        nonRawSize,

        mapTypeInt,
        
        strangeFileStringsSize,
        strangeFileStringsOffset,

        stringsOffset128,
        stringCount,
        stringsSize,
        stringsIndex,
        stringsOffset,

        fileTableCount,
        fileTableOffset,
        fileTableSize,
        fileTableIndexOffset,

        checksum;

        public Header(BinaryReader br)
        {
            char chr; //temp

            //the header (deah)
            head = Map.Reverse(new string(br.ReadChars(4)));

            //the Map version, halo2 maps are v8
            version = br.ReadInt32();

            //the total count of the bytes that make up the Map
            filesize = br.ReadInt32();

            //+4
            br.BaseStream.Position = 16;

            //the offset of the index
            indexOffset = br.ReadInt32();

            //the total length in bytes of the index
            indexSize = br.ReadInt32();

            //the start of the meta (stragiht after the index)
            metaStart = indexOffset + indexSize;

            //the total length in bytes of the meta
            metaSize = br.ReadInt32();

            //MetaSize + index Size + BSP Size
            nonRawSize = br.ReadInt32();

            //Map origin
            origin = "";
            while ((chr = br.ReadChar()) != '\0')
                origin += chr;

            br.BaseStream.Position = 288;

            //the final build date 00.00.00
            buildDate = "";
            while ((chr = br.ReadChar()) != '\0')
                buildDate += chr;

            br.BaseStream.Position = 320;

            //a number representing the type of the Map
            //0=sp 1=mp 2=mm 3=shared 4=spshared
            mapTypeInt = br.ReadInt32();

            //+16
            br.BaseStream.Position = 340;

            //the size and offset of the strange file strings
            strangeFileStringsSize = br.ReadInt32();
            strangeFileStringsOffset = br.ReadInt32();

            //+4
            br.BaseStream.Position = 352;

            //string info
            stringsOffset128 = br.ReadInt32();
            stringCount = br.ReadInt32();
            stringsSize = br.ReadInt32();
            stringsIndex = br.ReadInt32();
            stringsOffset = br.ReadInt32();

            //+36
            br.BaseStream.Position = 408;

            //forms the internal name of the Map - e.g. lockout
            internalName = "";
            while ((chr = br.ReadChar()) != '\0')
                internalName += chr;

            br.BaseStream.Position = 444;

            //forms the maps scenario name - e.g. scenario\multi\lockout\lockout
            scenarioName = "";
            while ((chr = br.ReadChar()) != '\0')
                scenarioName += chr;

            //+10
            br.BaseStream.Position = 704;

            //file strings info
            fileTableCount = br.ReadInt32();
            fileTableOffset = br.ReadInt32();
            fileTableSize = br.ReadInt32();
            fileTableIndexOffset = br.ReadInt32();

            //maps safecheck, its every byte after the header(2048bytes) xored
            checksum = br.ReadInt32();

            //+1320
            br.BaseStream.Position = 2044;

            //the footer (toof)
            foot = Map.Reverse(new string(br.ReadChars(4)));
        }
    }
}
