using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.ComponentModel;

namespace Blu
{
    public class Index
    {
        //index info
        public int
        primaryMagicConstant,
        primaryMagic,

        objectIndexPointer,
        offsetOfObjectIndex,

        scnrID,
        firstID,

        objectCount,

        secondaryMagicConstant,
        secondaryMagic;

        public string tags;

        public Index(BinaryReader br)
        {
            //the starting point of the index
            br.BaseStream.Position = Map.header.indexOffset;

            //math to get our primary magic :P
            primaryMagicConstant = br.ReadInt32();
            primaryMagic = primaryMagicConstant - (Map.header.indexOffset + 32);

            br.BaseStream.Position += 4;

            //the objects index (the tags)
            objectIndexPointer = br.ReadInt32();
            offsetOfObjectIndex = objectIndexPointer - primaryMagic;

            //ident of the scnr tag
            scnrID = br.ReadInt32();

            //the very first ident (norm 'matg' tag)
            firstID = br.ReadInt32();

            br.BaseStream.Position += 4;

            //the total amount of tags in the Map
            objectCount = br.ReadInt32();

            // sgat
            tags = Map.Reverse(new string(br.ReadChars(4)));

            //start of tags + 8 (skips matg tags tagtype and ident)
            br.BaseStream.Position = offsetOfObjectIndex + 8;

            //constant is raw meta offset of matg tag
            secondaryMagicConstant = br.ReadInt32();
            secondaryMagic = secondaryMagicConstant - Map.header.metaStart;
        }
    }
}
