using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Blu
{
    public struct Tag
    {
        public int Ident;
        public string Type;
        public string Path;
        public int MetaOffset;
        public int MetaSize;
    }

    public class Tags
    {
        public Tag[] tagsList;

        public Tags(BinaryReader br)
        {
            br.BaseStream.Position = Map.index.offsetOfObjectIndex;

            //will store the tags of the Map
            tagsList = new Tag[Map.index.objectCount];

            //count through the 'said' tag amount
            for (int x = 0; x < Map.index.objectCount; x++)
            {
                //and this is the rest of the info
                tagsList[x].Type = Map.Reverse(new string(br.ReadChars(4)));
                tagsList[x].Ident = br.ReadInt32();
                tagsList[x].MetaOffset = br.ReadInt32() - Map.index.secondaryMagic;
                tagsList[x].MetaSize = br.ReadInt32();
            }

            //go to the filetable which contains all the strings - globals/globals etc
            br.BaseStream.Position = (int)Map.header.fileTableOffset;

            //go through the tags and add in their paths
            char chr;
            for (int i = 0; i < Map.index.objectCount; i++)
            {
                while ((chr = br.ReadChar()) != '\0')
                    tagsList[i].Path += chr;
            }
        }
    }
}