using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Blu
{
    public sealed class Map
    {
        public static string path;

        public static Header header;
        public static Index index;
        public static Tags tags;
        public static Strings strings;
        public static Unicode unicode;

        public static ToolStripProgressBar ProgressBar;
        public static ToolStripStatusLabel ProgressLabel;

        public static void Load(string mpath)
        {
            path = mpath;

            BinaryReader br = new BinaryReader(new FileStream(path, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite));

            UpdateProgress("Reading Header...", 1); header = new Header(br);
            UpdateProgress("Reading Index...", 2); index = new Index(br);
            UpdateProgress("Reading Tags...", 3); tags = new Tags(br);
            UpdateProgress("Reading Strings...", 4); strings = new Strings(br);
            UpdateProgress("Reading Unicode...", 5); unicode = new Unicode(br);

            br.Close();
        }

        public static string Reverse(string str)
        {
            char[] temp = str.ToCharArray();
            Array.Reverse(temp);
            return new string(temp);

            //OR
            //string rslt = "";
            //for (int x = str.Length - 1; x >= 0; x--)
            //    rslt += str.Substring(x, 1);
            //return rslt;
        }

        public static bool IsInternal(int Pointer)
        {
            long num = Pointer & 0xC0000000;
            //Pointer &= (int)0x3FFFFFFF;
            return num == 0 ? true : false;
        }

        #region Progress
        public static void StartProgress(int max)
        {
            ProgressBar.Value = 0;
            ProgressBar.Maximum = max < 0 ? 0 : max;
        }

        public static void UpdateProgress(string txt, int val)
        {
            ProgressLabel.Text = txt;
            ProgressBar.Value = val <= ProgressBar.Maximum ? val : ProgressBar.Maximum;
            Application.DoEvents();
        }

        public static void EndProgress()
        {
            ProgressBar.Value = 0;
            ProgressLabel.Text = "Idle";
        }
        #endregion
    }
}