using System;
using System.Collections.Generic;
using System.Text;

namespace Menu_Menu_Menu
{
    public class DecodeDXT
    {
        ImageLib il = new ImageLib();

        // DecodeDXT1
        public byte[] DecodeDXT1(int height, int width, byte[] SourceData)
        {
            ImageLib.RGBA_IntColor[] Color = new ImageLib.RGBA_IntColor[5];
            
            ImageLib.RGBA_IntColor CColor;
            ImageLib.RGBA_IntColor zeroColor;

            int CData;
            int c1;
            int c2;
            int dptr = 0;

            bool trans;
            byte[] DestData = new byte[(width * height) * 4];

            int ChunksPerHLine = width / 4;
            if (ChunksPerHLine == 0) ChunksPerHLine = 1;

            for (int i = 0; i < (width * height); i += 16)
            {
                c1 = (SourceData[dptr + 1] << 8) | (SourceData[dptr]);
                c2 = (SourceData[dptr + 3] << 8) | (SourceData[dptr + 2]);

                trans = (!(c1 > c2));

                Color[0] = il.short_to_rgba(c1);
                Color[1] = il.short_to_rgba(c2);

                if (!trans)
                {
                    Color[2] = il.GradientColors(Color[0], Color[1]);
                    Color[3] = il.GradientColors(Color[1], Color[0]);
                }
                else
                {
                    zeroColor = Color[0];
                    Color[2] = il.GradientColorsHalf(Color[0], Color[1]);
                    Color[3] = zeroColor;
                }

                CData = (SourceData[dptr + 4] << 0) | (SourceData[dptr + 5] << 8) | 
                    (SourceData[dptr + 6] << 16) | (SourceData[dptr + 7] << 24);

                int ChunkNum = i / 16;
                long XPos = ChunkNum % ChunksPerHLine;
                long YPos = (ChunkNum - XPos) / ChunksPerHLine;

                long tmp1, tmp2;

                int sizeh = height < 4 ? height : 4;
                int sizew = width < 4 ? width : 4;

                int x, y;
                for (x = 0; x < sizeh; x++)
                {
                    for (y = 0; y < sizew; y++)
                    {
                        CColor = Color[CData & 3];
                        CData >>= 2;
                        tmp1 = ((YPos * 4 + x) * width + XPos * 4 + y) * 4;
                        tmp2 = il.rgba_to_int(CColor);
                        DestData[tmp1] = Convert.ToByte(CColor.b);
                        DestData[tmp1 + 1] = Convert.ToByte(CColor.g);
                        DestData[tmp1 + 2] = Convert.ToByte(CColor.r);
                        DestData[tmp1 + 3] = Convert.ToByte(CColor.a);
                    }
                }
                dptr += 8;
            }
            return DestData;
        }

        // DecodeDXT2/3
        public byte[] DecodeDXT23(int height, int width, byte[] SourceData)
        {
            ImageLib.RGBA_IntColor[] Color = new ImageLib.RGBA_IntColor[5];

            ImageLib.RGBA_IntColor CColor;
            ImageLib.RGBA_IntColor c1, c2, c3, c4;
            int CData;
            byte[] DestData = new byte[(width * height) * 4];

            int ChunksPerHLine = width / 4;
            if (ChunksPerHLine == 0) ChunksPerHLine = 1;

            for (int i = 0; i < (width * height); i += 16)
            {
                c1 = il.short_to_rgba((SourceData[i + 8]) | (SourceData[i + 9] << 8));
                c2 = il.short_to_rgba((SourceData[i + 10]) | (SourceData[i + 11] << 8));
                c3 = il.GradientColors(Color[0], Color[1]);
                c4 = il.GradientColors(Color[1], Color[0]);
                Color[0] = c1;
                Color[1] = c2;
                Color[2] = c3;
                Color[3] = c4;

                CData = (SourceData[i + 12] << 0) | (SourceData[i + 13] << 8) | (SourceData[i + 14] << 16) | (SourceData[i + 15] << 24);

                int ChunkNum = i / 16;
                long XPos = ChunkNum % ChunksPerHLine;
                long YPos = (ChunkNum - XPos) / ChunksPerHLine;

                long ttmp;

                int alpha;
                int sizeh = height < 4 ? height : 4;
                int sizew = width < 4 ? width : 4;
                int x, y;

                for (x = 0; x < sizeh; x++)
                {
                    alpha = SourceData[i + (2 * x)] | (SourceData[i + (2 * x) + 1]) << 8;
                    for (y = 0; y < sizew; y++)
                    {
                        CColor = Color[CData & 3];
                        CData >>= 2;
                        CColor.a = (alpha & 15) * 16;
                        alpha >>= 4;
                        ttmp = ((YPos * 4 + x) * width + XPos * 4 + y) * 4;

                        DestData[ttmp] = (byte)CColor.b;
                        DestData[ttmp + 1] = (byte)CColor.g;
                        DestData[ttmp + 2] = (byte)CColor.r;
                        DestData[ttmp + 3] = (byte)CColor.a;
                    }
                }
            }
            return DestData;
        }

        // DecodeDXT4/5
        public byte[] DecodeDXT45(int height, int width, byte[] SourceData)
        {
            ImageLib.RGBA_IntColor[] Color = new ImageLib.RGBA_IntColor[4];
            ImageLib.RGBA_IntColor CColor;

            int CData;
            byte[] DestData = new byte[(width * height) * 4];

            int ChunksPerHLine = width / 4;
            if (ChunksPerHLine == 0) ChunksPerHLine = 1;

            for (int i = 0; i < (width * height); i += 16)
            {
                Color[0] = il.short_to_rgba(SourceData[i + 8] | (SourceData[i + 9] << 8));
                Color[1] = il.short_to_rgba(SourceData[i + 10] | (SourceData[i + 11] << 8));
                Color[2] = il.GradientColors(Color[0], Color[1]);
                Color[3] = il.GradientColors(Color[1], Color[0]);

                CData = (SourceData[i + 12] << 0) | (SourceData[i + 13] << 8) | (SourceData[i + 14] << 16) | (SourceData[i + 15] << 24);

                byte[] Alpha = new byte[8];
                Alpha[0] = SourceData[i];
                Alpha[1] = SourceData[i + 1];

                //Do the alphas
                if (Alpha[0] > Alpha[1])
                {
                    // 8-alpha block:  derive the other six alphas.
                    // Bit code 000 = alpha_0, 001 = alpha_1, others are interpolated.

                    Alpha[2] = (byte)((6 * Alpha[0] + 1 * Alpha[1] + 3) / 7); // bit code 010
                    Alpha[3] = (byte)((5 * Alpha[0] + 2 * Alpha[1] + 3) / 7); // bit code 011
                    Alpha[4] = (byte)((4 * Alpha[0] + 3 * Alpha[1] + 3) / 7); // bit code 100
                    Alpha[5] = (byte)((3 * Alpha[0] + 4 * Alpha[1] + 3) / 7); // bit code 101
                    Alpha[6] = (byte)((2 * Alpha[0] + 5 * Alpha[1] + 3) / 7); // bit code 110
                    Alpha[7] = (byte)((1 * Alpha[0] + 6 * Alpha[1] + 3) / 7); // bit code 111
                }
                else
                {
                    // 6-alpha block.
                    // Bit code 000 = alpha_0, 001 = alpha_1, others are interpolated.
                    Alpha[2] = (byte)((4 * Alpha[0] + 1 * Alpha[1] + 2) / 5); // Bit code 010
                    Alpha[3] = (byte)((3 * Alpha[0] + 2 * Alpha[1] + 2) / 5); // Bit code 011
                    Alpha[4] = (byte)((2 * Alpha[0] + 3 * Alpha[1] + 2) / 5); // Bit code 100
                    Alpha[5] = (byte)((1 * Alpha[0] + 4 * Alpha[1] + 2) / 5); // Bit code 101
                    Alpha[6] = 0;            // Bit code 110
                    Alpha[7] = 255;          // Bit code 111
                }

                // Byte	Alpha
                // 0	Alpha_0
                // 1	Alpha_1 
                // 2	(0)(2) (2 LSBs), (0)(1), (0)(0)
                // 3	(1)(1) (1 LSB), (1)(0), (0)(3), (0)(2) (1 MSB)
                // 4	(1)(3), (1)(2), (1)(1) (2 MSBs)
                // 5	(2)(2) (2 LSBs), (2)(1), (2)(0)
                // 6	(3)(1) (1 LSB), (3)(0), (2)(3), (2)(2) (1 MSB)
                // 7	(3)(3), (3)(2), (3)(1) (2 MSBs)
                // (0

                // Read an int and a short
                int tmpword = SourceData[i + 2] | (SourceData[i + 3] << 8);
                long tmpdword = SourceData[i + 4] | (SourceData[i + 5] << 8) | (SourceData[i + 6] << 16) | (SourceData[i + 7] << 24);

                long alphaDat = tmpword | (tmpdword << 16);

                int ChunkNum = i / 16;
                long XPos = ChunkNum % ChunksPerHLine;
                long YPos = (ChunkNum - XPos) / ChunksPerHLine;
                long ttmp;
                int sizeh = height < 4 ? height : 4;
                int sizew = width < 4 ? width : 4;
                int x, y;
                for (x = 0; x < sizeh; x++)
                {
                    for (y = 0; y < sizew; y++)
                    {
                        CColor = Color[CData & 3];
                        CData >>= 2;
                        CColor.a = Alpha[alphaDat & 7];
                        alphaDat >>= 3;
                        ttmp = ((YPos * 4 + x) * width + XPos * 4 + y) * 4;
                        DestData[ttmp] = (byte)CColor.b;
                        DestData[ttmp + 1] = (byte)CColor.g;
                        DestData[ttmp + 2] = (byte)CColor.r;
                        DestData[ttmp + 3] = (byte)CColor.a;
                    }
                }
            }
            return DestData;
        }
    }

    public class ImageLib
    {
        public struct RGBA_IntColor
        {
            public int r, g, b, a;
        }

        public struct RGBA_ByteColor
        {
            public byte r, g, b, a;
        }

        public RGBA_IntColor short_to_rgba(int color)
        {
            RGBA_IntColor rcs;
            color = Convert.ToUInt16(color);
            rcs.r = (((color >> 11) & 31) * 255) / 31;
            rcs.g = (((color >> 5) & 63) * 255) / 63;
            rcs.b = (((color >> 0) & 31) * 255) / 31;
            rcs.a = 255;
            return rcs;
        }

        public int rgba_to_int(RGBA_IntColor rcs)
        {
            return (rcs.a << 24) | (rcs.r << 16) | (rcs.g << 8) | rcs.b;
        }

        public RGBA_IntColor GradientColors(RGBA_IntColor Col1, RGBA_IntColor Col2)
        {
            RGBA_IntColor ret;
            ret.r = ((Col1.r * 2 + Col2.r)) / 3;
            ret.g = ((Col1.g * 2 + Col2.g)) / 3;
            ret.b = ((Col1.b * 2 + Col2.b)) / 3;
            ret.a = 255;
            return ret;
        }

        public RGBA_IntColor GradientColorsHalf(RGBA_IntColor Col1, RGBA_IntColor Col2)
        {
            RGBA_IntColor ret;
            ret.r = (Col1.r / 2 + Col2.r / 2);
            ret.g = (Col1.g / 2 + Col2.g / 2);
            ret.b = (Col1.b / 2 + Col2.b / 2);
            ret.a = 255;
            return ret;
        }
    }
}
