using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.ComponentModel;

namespace Menu_Menu_Menu
{
    public class Index
    {
        public Map map;

        //index info
        public int
        primaryMagicConstant,
        primaryMagic,

        objectIndexPointer,
        offsetOfObjectIndex,

        scnrID,
        firstID,

        objectCount,

        secondaryMagicConstant,
        secondaryMagic;

        public string tags;

        public Index(Map map, BinaryReader br)
        {
            this.map = map;

            //the starting point of the index
            br.BaseStream.Position = map.header.indexOffset;

            //math to get our primary magic :P
            primaryMagicConstant = br.ReadInt32();
            primaryMagic = primaryMagicConstant - (map.header.indexOffset + 32);

            br.BaseStream.Position += 4;

            //the objects index (the tags)
            objectIndexPointer = br.ReadInt32();
            offsetOfObjectIndex = objectIndexPointer - primaryMagic;

            //ident of the scnr tag
            scnrID = br.ReadInt32();

            //the very first ident (norm 'matg' tag)
            firstID = br.ReadInt32();

            br.BaseStream.Position += 4;

            //the total amount of tags in the map
            objectCount = br.ReadInt32();

            // sgat
            tags = map.Reverse(new string(br.ReadChars(4)));

            //start of tags + 8 (skips matg tags tagtype and ident)
            br.BaseStream.Position = offsetOfObjectIndex + 8;

            //constant is raw meta offset of matg tag
            secondaryMagicConstant = br.ReadInt32();
            secondaryMagic = secondaryMagicConstant - map.header.metaStart;
        }

        public void WriteIndex()
        {
            BinaryWriter bw = new BinaryWriter(new FileStream(map.path, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite));

            bw.BaseStream.Position = map.header.indexOffset;
            bw.Write(primaryMagicConstant);

            bw.BaseStream.Position += 4;

            bw.Write(objectIndexPointer);
            bw.Write(scnrID);
            bw.Write(firstID);

            bw.BaseStream.Position += 4;

            bw.Write(objectCount);
            bw.Write(tags.ToCharArray());

            bw.BaseStream.Position = offsetOfObjectIndex + 8;
            bw.Write(secondaryMagicConstant);

            bw.Close();
        }
    }
}
