using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Menu_Menu_Menu
{
    public class Map
    {
        public string path;

        public Header header;
        public Index index;
        public Tags tags;
        public Strings strings;

        public BitmapSpecific bitm;

        public ToolStripProgressBar ProgressBar;
        public ToolStripStatusLabel ProgressLabel;

        public Map(ToolStripProgressBar progbar, ToolStripStatusLabel proglabel)
        {
            ProgressBar = progbar;
            ProgressLabel = proglabel;
        }

        public void Load(string mpath)
        {
            path = mpath;

            StartProgress(6);

            BinaryReader br = new BinaryReader(new FileStream(path, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite));

            UpdateProgress("Initializing...", 1); bitm = new BitmapSpecific(this);
            UpdateProgress("Reading Header...", 2); header = new Header(this, br);
            UpdateProgress("Reading Index...", 3); index = new Index(this, br);
            UpdateProgress("Reading Tags...", 4); tags = new Tags(this, br);
            UpdateProgress("Reading Strings...", 5); strings = new Strings(this, br);

            br.Close();
        }

        public string Reverse(string str)
        {
            char[] temp = str.ToCharArray();
            Array.Reverse(temp);
            return new string(temp);

            //OR
            //string rslt = "";
            //for (int x = str.Length - 1; x >= 0; x--)
            //    rslt += str.Substring(x, 1);
            //return rslt;
        }

        #region Progress
        public void StartProgress(int max)
        {
            ProgressBar.Value = 0;
            ProgressBar.Maximum = max < 0 ? 0 : max;
        }

        public void UpdateProgress(string txt, int val)
        {
            ProgressLabel.Text = txt;
            ProgressBar.Value = val <= ProgressBar.Maximum ? val : ProgressBar.Maximum;
            Application.DoEvents();
        }

        public void EndProgress()
        {
            ProgressBar.Value = 0;
            ProgressLabel.Text = "Idle";
        }
        #endregion
    }
}