using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Dark
{
    public partial class EntPreferences : Form
    {
        MapForm mf;
        bool bPage1, bPage2;

        public EntPreferences(MapForm mf)
        {
            InitializeComponent();
            this.mf = mf;
        }

        private void EntPreferences_Load(object sender, EventArgs e)
        {
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
                checkedListBox1.SetItemChecked(x, Globals.MetaEditorShownItems[x]);

            panel1.BackColor = Globals.ReflexiveStartingColor;
            trackBar1.Value = Globals.rShift;
            trackBar2.Value = Globals.gShift;
            trackBar3.Value = Globals.bShift;

            UpdatePreviewPanels();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
                checkedListBox1.SetItemChecked(x, true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
                checkedListBox1.SetItemChecked(x, false);
        }

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
            {
                if (x == e.Index)
                {
                    if (Globals.MetaEditorShownItems[x] != (e.NewValue == CheckState.Checked ? true : false))
                    {
                        button4.Enabled = true;
                        bPage1 = true;
                        return;
                    }
                }
                else
                {
                    if (Globals.MetaEditorShownItems[x] != checkedListBox1.GetItemChecked(x))
                    {
                        button4.Enabled = true;
                        bPage1 = true;
                        return;
                    }
                }
            }
            if (!bPage2) button4.Enabled = false;
            bPage1 = false;
        }

        private void panel1_Click(object sender, EventArgs e)
        {
            cd1.Color = panel1.BackColor;
            if (cd1.ShowDialog() == DialogResult.Cancel) return;
            panel1.BackColor = cd1.Color;

            UpdatePreviewPanels();
        }

        private void trackBar123_Scroll(object sender, EventArgs e)
        {
            UpdatePreviewPanels();
        }

        public void UpdatePreviewPanels()
        {
            Color clr = panel2.BackColor = panel1.BackColor;
            for (int x = 3; x < 22; x++)
            {
                //update clr
                int tmpR = clr.R + trackBar1.Value;
                tmpR = tmpR > 255 ? panel2.BackColor.R : tmpR;

                int tmpG = clr.G + trackBar2.Value;
                tmpG = tmpG > 255 ? panel2.BackColor.G : tmpG;

                int tmpB = clr.B + trackBar3.Value;
                tmpB = tmpB > 255 ? panel2.BackColor.B : tmpB;

                clr = Color.FromArgb(tmpR, tmpG, tmpB);

                //set clr
                tabPage2.Controls["panel" + x.ToString()].BackColor = clr;
            }

            if (panel1.BackColor == Globals.ReflexiveStartingColor && trackBar1.Value == Globals.rShift
                && trackBar2.Value == Globals.gShift && trackBar3.Value == Globals.bShift)
            {
                if (!bPage1) button4.Enabled = false;
                bPage2 = false;
            }
            else
            {
                button4.Enabled = true;
                bPage2 = true;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //visible items
            for (int x = 0; x < checkedListBox1.Items.Count; x++)
                Globals.MetaEditorShownItems[x] = checkedListBox1.GetItemChecked(x);

            //reflexive colouring
            Globals.ReflexiveStartingColor = mf.pluginpanel.BackColor = panel1.BackColor;
            Globals.rShift = trackBar1.Value;
            Globals.gShift = trackBar2.Value;
            Globals.bShift = trackBar3.Value;

            if (bPage1)
            {
                mf.map.entReader.UpdateMetaVisibility();
                mf.map.entReader.InitializeMetaControls();
                mf.map.entReader.ReadMetaValues();
                mf.map.entReader.DisplayMeta(mf.pluginpanel);

                Application.DoEvents();
                mf.pluginpanel_Resize(null, null);
            }
            else if (bPage2 && Globals.MetaEditorShownItems[0])
            {
                for (int x = 0; x < mf.map.entReader.Nodes.Count; x++)
                {
                    if (mf.map.entReader.Nodes[x].NodeType == NodeType.Reflexive)
                    {
                        Color clr = (mf.map.entReader.Nodes[x] as StructNode).Parent == null ?
                            Globals.ReflexiveStartingColor
                            : (mf.map.entReader.Nodes[x] as StructNode).Parent.Colour;

                        int tmpR = clr.R + Globals.rShift;
                        tmpR = tmpR > 255 ? Globals.ReflexiveStartingColor.R : tmpR;

                        int tmpG = clr.G + Globals.gShift;
                        tmpG = tmpG > 255 ? Globals.ReflexiveStartingColor.G : tmpG;

                        int tmpB = clr.B + Globals.bShift;
                        tmpB = tmpB > 255 ? Globals.ReflexiveStartingColor.B : tmpB;

                        (mf.map.entReader.Nodes[x] as StructNode).Colour =
                        (mf.map.entReader.Nodes[x] as StructNode).panel.BackColor =
                        Color.FromArgb(tmpR, tmpG, tmpB);
                    }
                }
            }

            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}