using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Net;

namespace Dark
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Globals.Load();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (o.ShowDialog() == DialogResult.Cancel) return;

            //else
            foreach (string path in o.FileNames)
            {
                MapForm mf = new MapForm(path, pb1, stat);
                mf.MdiParent = this;
                mf.Show();
                mf.WindowState = FormWindowState.Maximized;
            }
        }

        private void windowsToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            switch (this.MdiChildren.Length)
            {
                case 0:
                    tileHorizontallyToolStripMenuItem.Enabled =
                    tileVerticallyToolStripMenuItem.Enabled =
                    cascadeToolStripMenuItem.Enabled =
                    toolStripSeparator3.Visible = false;
                    break;

                case 1:
                    tileHorizontallyToolStripMenuItem.Enabled =
                    tileVerticallyToolStripMenuItem.Enabled =
                    cascadeToolStripMenuItem.Enabled = false;
                    toolStripSeparator3.Visible = true;
                    break;

                default:
                    tileHorizontallyToolStripMenuItem.Enabled =
                    tileVerticallyToolStripMenuItem.Enabled =
                    cascadeToolStripMenuItem.Enabled =
                    toolStripSeparator3.Visible = true;
                    break;
            }
        }

        private void tileHorizontallyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void tileVerticallyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileVertical);
        }

        private void cascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.Cascade);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void halomodsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Process.Start("http://forums.halomods.com/");
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Lead Programmer: Prey" + Environment.NewLine + "(Something soon to come): Matt", "About",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            Globals.Save();
        }

        private void toolsToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            switch (this.MdiChildren.Length)
            {
                case 0:
                    resignToolStripMenuItem.Enabled =
                    resignAllToolStripMenuItem.Enabled = false;
                    break;

                case 1:
                    resignToolStripMenuItem.Enabled = (this.ActiveMdiChild != null);
                    resignAllToolStripMenuItem.Enabled = false;
                    break;

                default:
                    resignToolStripMenuItem.Enabled = (this.ActiveMdiChild != null);
                    resignAllToolStripMenuItem.Enabled = true;
                    break;
            }
        }

        private void resignToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FileStream fs = new FileStream((this.ActiveMdiChild as MapForm).map.path,
                FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);

            BinaryReader br = new BinaryReader(fs);
            BinaryWriter bw = new BinaryWriter(fs);

            int sig = 0;
            long length = br.BaseStream.Length;

            br.BaseStream.Position = 2048;

            for (long i = 2048; i < length; i += 4)
                sig ^= br.ReadInt32();

            bw.BaseStream.Position = 720;
            bw.Write(sig);

            br.Close();
            bw.Close();

            (this.ActiveMdiChild as MapForm).map.header.checksum = sig;

            MessageBox.Show("Done! New Signature is 0x" + sig.ToString("X"), "",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void resignAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int x = 0; x < this.MdiChildren.Length; x++)
            {
                FileStream fs = new FileStream((this.MdiChildren[x] as MapForm).map.path,
                    FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);

                BinaryReader br = new BinaryReader(fs);
                BinaryWriter bw = new BinaryWriter(fs);

                int sig = 0;
                long length = br.BaseStream.Length;

                br.BaseStream.Position = 2048;

                for (long i = 2048; i < length; i += 4)
                    sig ^= br.ReadInt32();

                br.BaseStream.Position = 720;
                bw.Write(sig);

                br.Close();
                bw.Close();

                (this.MdiChildren[x] as MapForm).map.header.checksum = sig;
            }

            MessageBox.Show("Done! " + this.MdiChildren.Length.ToString() + " maps resigned successfully", "",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void Form1_MdiChildActivate(object sender, EventArgs e)
        {
            MapForm mf = (this.ActiveMdiChild as MapForm);
            if (mf == null) Globals.DevWindow = null;
            else
            {
                if (mf.map.mode.Init) mf.map.mode.RefreshMoi();
                else Globals.DevWindow = null;
            }
        }
    }
}