using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using Microsoft.DirectX.AudioVideoPlayback;
using Microsoft.DirectX.Direct3D;
using Microsoft.DirectX;

namespace Dark
{
    //Anything in here is here because it only needs to be defined once and yet be accessible from everywhere
    public sealed class Globals
    {
        public static string[] mapHashes = new string[31];

        public static string
        drive = Path.GetPathRoot(Application.StartupPath),
        folder = drive + "Program Files\\Homebrewgames\\Profane\\",
        sav = folder + "Settings.cfg",

        mainMenuLoc, sharedLoc, singlePlayerSharedLoc;

        public static bool devLoaded;
        public static Device dev = null;
        public static ThreeD DevWindow;

        public static List<string> SoundCachePaths = new List<string>();

        public static bool[] MetaEditorShownItems = new bool[23];
        public static Color ReflexiveStartingColor;
        public static int rShift, gShift, bShift;

        public static short[] uniDwords = new short[24];
        public static string[] uniTranslations = new string[24];

        public static List<TreeNode> clonerMemoryNodes = new List<TreeNode>();

        public static void Load()
        {
            mapHashes[0] = "82A549E558DBF7CAE0E3808A72CBDF80"; //00a_introduction.map
            mapHashes[1] = "473CF8566814A9E0E9A42B7E973101A"; //01a_tutorial.map
            mapHashes[2] = "B6A293BF3ABE555EF069904D202040"; //01b_spacestation.map
            mapHashes[3] = "CC24C49BE47656D7B0C592CA9EE9380"; //03a_oldmombasa.map
            mapHashes[4] = "1488B88F9862AE3D9FA1700802398A9"; //03b_newmombasa.map
            mapHashes[5] = "6039385CD45EAAEFCA49FCB6156688C1"; //04a_gasgiant.map
            mapHashes[6] = "C513A7EA24C7ADBF5722C71145155B58"; //04b_floodlab.map
            mapHashes[7] = "3D7CC457895531F5363D581596CE1C7F"; //05a_deltaapproach.map
            mapHashes[8] = "D7F57B42F552E7A3E7C229A6D7B6C290"; //05b_deltatowers.map
            mapHashes[9] = "9394AC858676C6E16313E07B06676E1"; //06a_sentinelwalls.map
            mapHashes[10] = "F862158BA893F0BF865267FB90CC5DF"; //06b_floodzone.map
            mapHashes[11] = "1F1D6A29443CFE1A6BD6ED4BE8B24F3B"; //07a_highcharity.map
            mapHashes[12] = "66AA9C5CB9483348A412ECA29870654B"; //07b_forerunnership.map
            mapHashes[13] = "B5D55BE3AB4F5D989CDD6E02BCEC7AE"; //08a_deltacliffs.map
            mapHashes[14] = "2854325521FAE51BBBDE94464711E6C"; //08b_deltacontrol.map

            mapHashes[15] = "8139778B53791BA3988D989BF8C"; //ascension.map
            mapHashes[17] = "B4A8B96A4EFA31F5D171443EE3D885B"; //beavercreek.map
            mapHashes[18] = "2758D6CEA0A214A0F1DDAF7732AEDBE"; //burial_mounds.map
            mapHashes[19] = "281D7967CA7229E7AAE2F469ACB45E3"; //coagulation.map
            mapHashes[20] = "E095792228762572F9861D17D27C"; //colossus.map
            mapHashes[21] = "F1C894685825F7ED9FF50A4EEFE468"; //cyclotron.map
            mapHashes[22] = "80F0498DC74470FC07B35ABDE5CE75"; //foundation.map
            mapHashes[23] = "B9CA53634E22709064F24B3D9D505A"; //headlong.map
            mapHashes[24] = "46FA3C9920EB32A7B22D6DC61C24317C"; //lockout.map
            mapHashes[25] = "689067B0DF3ADBC7A8C34E7F0CEF136"; //midship.map
            mapHashes[26] = "F2FF5949AB39878BE9277348332A74F"; //waterworks.map
            mapHashes[27] = "A360BF5A2BB41D6B477B167E49B8325F"; //zanzibar.map

            mapHashes[28] = "53E0A730E4DD7393B0B6D7DE663FE83"; //mainmenu.map
            mapHashes[29] = "ACE4A0C4887C5388E4B581FE91F64429"; //shared.map
            mapHashes[30] = "F3D0376F35FE47C4B47223D97208E"; //single_player_shared.map

            if (File.Exists(sav))
            {
                StreamReader sr = File.OpenText(sav);

                mainMenuLoc = sr.ReadLine();
                sharedLoc = sr.ReadLine();
                singlePlayerSharedLoc = sr.ReadLine();

                for (int x = 0; x < MetaEditorShownItems.Length; x++)
                    MetaEditorShownItems[x] = bool.Parse(sr.ReadLine());

                ReflexiveStartingColor = Color.FromArgb(int.Parse(sr.ReadLine()));
                rShift = int.Parse(sr.ReadLine());
                gShift = int.Parse(sr.ReadLine());
                bShift = int.Parse(sr.ReadLine());

                sr.Close();
            }
            else
            {
                for (int x = 0; x < MetaEditorShownItems.Length; x++)
                    MetaEditorShownItems[x] = true;

                //invisible, unused and undefined
                MetaEditorShownItems[4] =
                MetaEditorShownItems[5] =
                MetaEditorShownItems[6] = false;

                ReflexiveStartingColor = Color.FromArgb(-7951188);
                rShift = 56;
                gShift = 39;
                bShift = 9;
            }

            uniDwords[0] = -30575;
            uniTranslations[0] = "[X]";

            uniDwords[1] = -30319;
            uniTranslations[1] = "[Y]";

            uniDwords[2] = -30063;
            uniTranslations[2] = "[B]";

            uniDwords[3] = -24700;
            uniTranslations[3] = "[ES]";

            uniDwords[4] = -24956;
            uniTranslations[4] = "[PR]";

            uniDwords[5] = -21884;
            uniTranslations[5] = "[BPR]";

            uniDwords[6] = -25212;
            uniTranslations[6] = "[PP]";

            uniDwords[7] = -27260;
            uniTranslations[7] = "[CC]";

            uniDwords[8] = -23164;
            uniTranslations[8] = "[D]";

            uniDwords[9] = -23420;
            uniTranslations[9] = "[BeamR]";

            uniDwords[10] = -27516;
            uniTranslations[10] = "[BS]";

            uniDwords[11] = -26748;
            uniTranslations[11] = "[FRC]";

            uniDwords[12] = -28028;
            uniTranslations[12] = "[BR]";

            uniDwords[13] = -25724;
            uniTranslations[13] = "[N]";

            uniDwords[14] = -25980;
            uniTranslations[14] = "[M]";

            uniDwords[15] = -24444;
            uniTranslations[15] = "[RL]";

            uniDwords[16] = -24188;
            uniTranslations[16] = "[S]";

            uniDwords[17] = -23932;
            uniTranslations[17] = "[SMG]";

            uniDwords[18] = -23676;
            uniTranslations[18] = "[SR]";

            uniDwords[19] = -22908;
            uniTranslations[19] = "[SB]";

            uniDwords[20] = -22396;
            uniTranslations[20] = "[SGL]";

            uniDwords[21] = -27772;
            uniTranslations[21] = "[BOMB]";

            uniDwords[22] = -25468;
            uniTranslations[22] = "[ODD]";

            uniDwords[23] = -27004;
            uniTranslations[23] = "[FLAG]";
        }

        public static void Save()
        {
            if (!Directory.Exists(folder))
                Directory.CreateDirectory(folder);

            StreamWriter sw = File.CreateText(sav);

            sw.WriteLine(mainMenuLoc);
            sw.WriteLine(sharedLoc);
            sw.WriteLine(singlePlayerSharedLoc);

            for (int x = 0; x < MetaEditorShownItems.Length; x++)
                sw.WriteLine(MetaEditorShownItems[x]);

            sw.WriteLine(ReflexiveStartingColor.ToArgb());
            sw.WriteLine(rShift);
            sw.WriteLine(gShift);
            sw.WriteLine(bShift);

            sw.Close();

            //here becuase Save() is called wen app closing
            for (int x =0;x<SoundCachePaths.Count ;x++)
                File.Delete(SoundCachePaths[x]);
        }

        public static FileStream returnStreamFromType(RawLocations loc)
        {
            string locPath = "";

            switch (loc)
            {
                case RawLocations.MainMenu:
                    locPath = mainMenuLoc;
                    break;

                case RawLocations.Shared:
                    locPath = sharedLoc;
                    break;

                case RawLocations.Single_Player_Shared:
                    locPath = singlePlayerSharedLoc;
                    break;
            }

            return File.Exists(locPath) ? new FileStream(locPath, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite) : null;
        }

        public static void PerformExternalMapNotFoundError()
        {
            MessageBox.Show("Loading Aborted. External Map Needed", "",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public static bool SetUpDevice(ThreeD window)
        {
            try
            {
                if (dev != null) dev.Dispose();

                // Get the ordinal for the default adapter
                int adapterOrdinal = Manager.Adapters.Default.Adapter;

                // Get our dev capabilities so we can check them to set up the CreateFlags
                Caps caps = Manager.GetDeviceCaps(adapterOrdinal, DeviceType.Hardware);
                CreateFlags createFlags;

                // Check the capabilities of the graphcis card is capable of
                // performing the vertex-processing operations
                // The HardwareVertexProcessing choice is the best
                if (caps.DeviceCaps.SupportsHardwareTransformAndLight) createFlags = CreateFlags.HardwareVertexProcessing;
                else createFlags = CreateFlags.SoftwareVertexProcessing;

                // If the graphics card supports vertex processing check if the dev can
                // do rasterization, matrix transformations, and lighting and shading operations
                // This combination provides the fastest game experience
                if (caps.DeviceCaps.SupportsPureDevice && createFlags == CreateFlags.HardwareVertexProcessing)
                    createFlags |= CreateFlags.PureDevice;

                // Set up the PresentParameters which determine how the dev behaves
                PresentParameters pp = new PresentParameters();
                pp.Windowed = true;
                pp.SwapEffect = SwapEffect.Discard;
                
                pp.EnableAutoDepthStencil = true;
                pp.AutoDepthStencilFormat = DepthFormat.D24S8;

                // Now create the dev
                dev = new Device(adapterOrdinal, DeviceType.Hardware, window, createFlags, pp);
                dev.DeviceReset += new EventHandler(OnResetDevice);
                OnResetDevice(dev, null);

                return devLoaded = true;
            }
            catch (DirectXException)
            {
                // Catch any errors and return a failure
                return devLoaded = false;
            }
        }

        public static void OnResetDevice(object sender, EventArgs e)
        {
            Globals.dev.RenderState.CullMode = Cull.None;
            Globals.dev.RenderState.Lighting = true;
            Globals.dev.RenderState.ZBufferEnable = true;
            Globals.dev.RenderState.ZBufferWriteEnable = true;

            if (Globals.dev.DeviceCaps.SourceBlendCaps.SupportsInverseSourceAlpha
                && Globals.dev.DeviceCaps.SourceBlendCaps.SupportsSourceAlpha)
            {
                Globals.dev.RenderState.SourceBlend = Blend.SourceAlpha;
                Globals.dev.RenderState.DestinationBlend = Blend.InvSourceAlpha;
            }
            if (Globals.dev.DeviceCaps.TextureFilterCaps.SupportsMinifyLinear)
            {
                Globals.dev.SamplerState[0].MinFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[1].MinFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[2].MinFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[3].MinFilter = TextureFilter.Linear;
            }
            if (Globals.dev.DeviceCaps.TextureFilterCaps.SupportsMagnifyLinear)
            {
                Globals.dev.SamplerState[0].MagFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[1].MagFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[2].MagFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[3].MagFilter = TextureFilter.Linear;
            }
            if (Globals.dev.DeviceCaps.TextureFilterCaps.SupportsMipMapLinear)
            {
                Globals.dev.SamplerState[0].MipFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[1].MipFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[2].MipFilter = TextureFilter.Linear;
                Globals.dev.SamplerState[3].MipFilter = TextureFilter.Linear;
            }

            Globals.dev.RenderState.Ambient = Color.FromArgb(0xAF, 0xAF, 0xAF);
        }

        public static string returnSoundCachePath()
        {
            string str = folder + "SoundCache" + SoundCachePaths.Count.ToString() + ".sc";
            SoundCachePaths.Add(str);
            return str;
        }

        public static void AddClonerMemoryNode(TreeNode node, Form1 form1)
        {
            clonerMemoryNodes.Add(node);

            foreach (MapForm mapform in form1.MdiChildren)
                mapform.tv4.Nodes.Add((TreeNode)node.Clone());
        }

        public static void RemoveClonerMemoryNode(int indx, Form1 form1)
        {
            clonerMemoryNodes.RemoveAt(indx);

            foreach (MapForm mapform in form1.MdiChildren)
                mapform.tv4.Nodes.RemoveAt(indx);
        }
    }
}
