using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Dark
{
    public class DetailsControl : Component
    {
        private Map map;
        public DetailsControl(Map map)
        {
            this.map = map;
        }

        [Category("Meta")]
        [Description("")]
        public int MetaOffset
        {
            get { return map.tags.tagsList[map.tags.selectedIndex].MetaOffset; }
            set { map.tags.tagsList[map.tags.selectedIndex].MetaOffset = value; }
        }

        [Category("Meta")]
        [Description("")]
        public int MetaSize
        {
            get { return map.tags.tagsList[map.tags.selectedIndex].MetaSize; }
            set { map.tags.tagsList[map.tags.selectedIndex].MetaSize = value; }
        }

        [Category("Misc")]
        [Description("")]
        public int Ident
        {
            get { return map.tags.tagsList[map.tags.selectedIndex].Ident; }
            set { map.tags.tagsList[map.tags.selectedIndex].Ident = value; }
        }

        [Category("Misc")]
        [Description("")]
        [TypeConverter(typeof(ValueTypeConverter))]
        public string Type
        {
            get { return map.tags.tagsList[map.tags.selectedIndex].Type; }
            set
            {
                if (value.Length == 4)
                    map.tags.tagsList[map.tags.selectedIndex].Type = value;
            }
        }

        internal string[] MapTagTypes
        {
            get { return map.tags.tagTypes.ToArray(); }
        }

        [Category("Misc")]
        [Description("")]
        public string Path
        {
            get { return map.tags.tagsList[map.tags.selectedIndex].Path; }
            set { map.tags.tagsList[map.tags.selectedIndex].Path = value; }
        }
    }

    public class ValueTypeConverter : TypeConverter
    {
        public override TypeConverter.StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            string[] myValues = (context.Instance as DetailsControl).MapTagTypes;
            return new StandardValuesCollection(myValues);
        }

        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            return true;
        }

        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            return true;
        }
    }
}
