using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Dark
{
    public class IndexControl : Component
    {
        private Map map;
        public IndexControl(Map map)
        {
            this.map = map;
        }

        [Category("Primary Magic")]
        [Description("A number used in the calculation of the primary magic")]
        public int PrimaryMagicConstant
        {
            get { return map.index.primaryMagicConstant; }
            set 
            { 
                map.index.primaryMagicConstant = value;

                map.index.primaryMagic =
                    map.index.primaryMagicConstant - (map.header.indexOffset + 32);
            }
        }

        [Category("Primary Magic")]
        [Description("Is the result of PrimaryMagicConstant - (IndexOffset + 32). Value is used when finding data within the map")]
        public int PrimaryMagic
        {
            get { return map.index.primaryMagic; }
        }

        [Category("Objects")]
        [Description("A number used to find the offset at which the objects begins")]
        public int ObjectIndexPointer
        {
            get { return map.index.objectIndexPointer; }
            set 
            { 
                map.index.objectIndexPointer = value;

                map.index.offsetOfObjectIndex =
                    map.index.objectIndexPointer - map.index.primaryMagic;
            }
        }

        [Category("Objects")]
        [Description("The offset at which the objects begins")]
        public int OffsetOfObjectIndex
        {
            get { return map.index.offsetOfObjectIndex; }
        }

        [Category("Misc")]
        [Description("The ID of the scnr tag")]
        public int ScnrID
        {
            get { return map.index.scnrID; }
            set { map.index.scnrID = value; }
        }

        [Category("Misc")]
        [Description("The first ID, usually the matg's")]
        public int FirstID
        {
            get { return map.index.firstID; }
            set { map.index.firstID = value; }
        }

        [Category("Objects")]
        [Description("The total amount of objects")]
        public int ObjectCount
        {
            get { return map.index.objectCount; }
            set { map.index.objectCount = value; }
        }

        [Category("Secondary Magic")]
        [Description("A number used in the calculation of the secondary magic")]
        public int SecondaryMagicConstant
        {
            get { return map.index.secondaryMagicConstant; }
            set 
            { 
                map.index.secondaryMagicConstant = value;

                map.index.secondaryMagic =
                    map.index.secondaryMagicConstant - map.header.metaStart;
            }
        }

        [Category("Secondary Magic")]
        [Description("Is the result of SecondaryMagicConstant - MetaStart. Value is used when finding data within the map")]
        public int SecondaryMagic
        {
            get { return map.index.secondaryMagic; }
        }
    }
}
