using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Dark
{
    public class BitmapData : RawDataHandler
    {
        public BitmapData(Map map, int TagIndx)
        {
            BinaryReader br = new BinaryReader(new FileStream(map.path, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite));

            br.BaseStream.Position = map.tags.tagsList[TagIndx].MetaOffset + 68;

            int tempc = br.ReadInt32(); //chunk count
            int tempr = br.ReadInt32() - map.index.secondaryMagic; //translation

            //foreach chunk
            for (int x = 0; x < tempc; x++)
            {
                //foreach chunk inside
                for (int y = 0; y < 6; y++)
                {
                    BitmapRawDataChunk brdc = new BitmapRawDataChunk();
                    brdc.chunkNum = x;
                    brdc.innerChunkNum = y;

                    brdc.PointerOffset = tempr + (x * 116) + 28 + (y * 4);
                    br.BaseStream.Position = brdc.PointerOffset;

                    brdc.Offset = br.ReadInt32(); //offset + raw location atm         
                    if (brdc.Offset == -1) break;

                    br.BaseStream.Position += 20;
                    brdc.Size = br.ReadInt32();

                    //pull out the raw location and fix the offset
                    map.rawData.ParseSPointer(ref brdc.Offset, ref brdc.rawLocation);

                    if (brdc.rawLocation == RawLocations.Internal)
                    {
                        br.BaseStream.Position = brdc.Offset;
                        brdc.MS = new MemoryStream(br.ReadBytes(brdc.Size));
                    }
                    else
                    {
                        FileStream fs = Globals.returnStreamFromType(brdc.rawLocation);
                        if (fs == null)
                        {
                            this.rawChunks.Clear();
                            this.Loaded = false;
                            Globals.PerformExternalMapNotFoundError();
                            return;
                        }
                        else
                        {
                            BinaryReader rawBr = new BinaryReader(fs);
                            rawBr.BaseStream.Position = brdc.Offset;
                            brdc.MS = new MemoryStream(rawBr.ReadBytes(brdc.Size));
                            rawBr.Close();
                        }
                    }

                    //add the raw chunk to the list
                    this.rawChunks.Add(brdc);
                }
            }
            br.Close();
            this.Loaded = true;
        }
    }
}
