using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Drawing.Imaging;
using System.Windows.Forms;
using Microsoft.DirectX.AudioVideoPlayback;

namespace Dark
{
    public class SoundSpecific
    {
        public Map map;
        public string audPath;
        public Audio aud;

        public SoundSpecific(Map map)
        {
            this.map = map;
            audPath = Globals.returnSoundCachePath();
        }

        public bool LoadSelectedSound(int type)
        {
            if (aud != null)
            {
                aud.Dispose();
                aud = null;
            }

            BinaryWriter bw = new BinaryWriter(new FileStream(audPath, FileMode.Create,
               FileAccess.ReadWrite, FileShare.ReadWrite));

            switch (type)
            {
                case 0:
                    bw.Write(new byte[] {82,73,70,70,100,48,0,0,87,65,86,69,102,109,116,32,
                        20,0,0,0,105,0,1,0,68,172,0,0,34,86,0,0,36,0,4,0,2,0,64,0,100,97,
                        116,97,56,48,0,0});
                    break;

                case 1:
                    bw.Write(new byte[] {82,73,70,70,128,68,0,0,87,65,86,69,102,109,116,32,
                        20,0,0,0,105,0,2,0,68,172,0,0,68,172,0,0,72,0,4,0,2,0,64,0,100,97,
                        116,97,84,68,0,0});
                    break;
            }

            foreach (RawDataChunk rdc in map.rawData.rdh.rawChunks)
                bw.Write(rdc.MS.ToArray());

            bw.Close();

            try
            {
                aud = new Audio(audPath);
            }
            catch
            {
                aud = null;
                audPath = Globals.returnSoundCachePath();
                return false;
            }
            return true;
        }

        public void ExtractSelectedSound(string writePath, int type)
        {
            BinaryWriter bw = new BinaryWriter(new FileStream(writePath, FileMode.Create,
                FileAccess.ReadWrite, FileShare.ReadWrite));

            switch (type)
            {
                case 0:
                    bw.Write(new byte[] {82,73,70,70,100,48,0,0,87,65,86,69,102,109,116,32,
                        20,0,0,0,105,0,1,0,68,172,0,0,34,86,0,0,36,0,4,0,2,0,64,0,100,97,
                        116,97,56,48,0,0});
                    break;

                case 1:
                    bw.Write(new byte[] {82,73,70,70,128,68,0,0,87,65,86,69,102,109,116,32,
                        20,0,0,0,105,0,2,0,68,172,0,0,68,172,0,0,72,0,4,0,2,0,64,0,100,97,
                        116,97,84,68,0,0});
                    break;
            }

            foreach (RawDataChunk rdc in map.rawData.rdh.rawChunks)
                bw.Write(rdc.MS.ToArray());

            bw.Close();
        }
    }
}
