using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

namespace Dark
{
    public class UnicodeSpecific
    {
        public Map map;

        public UnicodeSpecific(Map map)
        {
            this.map = map;
        }

        public void WriteUnicode(int langIndx, int strIndx, string newText)
        {
            BinaryWriter bw = new BinaryWriter(new FileStream(map.path, FileMode.Open,
              FileAccess.ReadWrite, FileShare.ReadWrite));

            UnicodeData ud = (map.rawData.rdh as UnicodeData);

            int strOffset = ud.langs[langIndx].tableOffset + ud.langs[langIndx].UniStrings[strIndx].Offset;
            bw.BaseStream.Position = strOffset;

            MemoryStream ms = new MemoryStream();

            //go throu newtext
            for (int x = 0; x < newText.Length; x++)
            {
                bool bool1 = false;
                for (int y=0; y<Globals.uniTranslations.Length ;y++)
                {
                    if (Globals.uniTranslations[y].Length <= newText.Length - x)
                    {
                        if (newText.Substring(x, Globals.uniTranslations[y].Length) == Globals.uniTranslations[y])
                        {
                            ms.WriteByte(238);
                            ms.Write(BitConverter.GetBytes(Globals.uniDwords[y]), 0, 2);

                            bool1 = true;
                            x += Globals.uniTranslations[y].Length-1;
                            break; //foreach loop
                        }
                    }
                }
                if (!bool1) ms.WriteByte((byte)newText[x]);
            }

            byte[] txtBytes = ms.ToArray();

            //hmm
            //for (int x = 0; x < Globals.uniTranslations.Length; x++)
            //{
            //    newText = newText.Replace(Globals.uniTranslations[x],
            //        BitConverter.ToString(BitConverter.GetBytes(Globals.uniDwords[x])));
            //}

            if (txtBytes.Length == ud.langs[langIndx].UniStrings[strIndx].Length) bw.Write(txtBytes);
            else
            {
                //open in reader
                BinaryReader br = new BinaryReader(bw.BaseStream);

                //goto end of string
                br.BaseStream.Position += ud.langs[langIndx].UniStrings[strIndx].Length;

                //store eof table
                byte[] eofLangTable = br.ReadBytes((ud.langs[langIndx].tableOffset
                    + ud.langs[langIndx].tableSize) - (int)br.BaseStream.Position);

                //next thing after padding of table
                int afterTablePadding = langIndx == ud.langs.Length - 1 ?
                    map.header.strangeFileStringsOffset : ud.langs[langIndx + 1].indexOffset;

                int oldPaddingLen = afterTablePadding - (int)br.BaseStream.Position;
                br.BaseStream.Position = afterTablePadding;

                //store map downward from pos
                byte[] mapHalf = br.ReadBytes((int)(br.BaseStream.Length - br.BaseStream.Position));

                //goto start of string
                bw.BaseStream.Position = strOffset;

                //write new text and eof
                bw.Write(txtBytes);
                bw.Write(eofLangTable);

                long langTableEnd = bw.BaseStream.Position;

                //shift
                int shift = txtBytes.Length - ud.langs[langIndx].UniStrings[strIndx].Length;

                //--[String offsets]

                //go 1 after the string in the index
                bw.BaseStream.Position = ud.langs[langIndx].indexOffset + (strIndx * 8) + 8;
                for (int x = strIndx + 1; x < ud.langs[langIndx].stringCount; x++)
                {
                    bw.BaseStream.Position += 4;
                    bw.Write(ud.langs[langIndx].UniStrings[x].Offset += shift);
                }

                //get padding length
                ud.langs[langIndx].tableSize += shift;
                int newPaddingLen = 512 - (ud.langs[langIndx].tableSize % 512);

                bw.BaseStream.Position = langTableEnd;
                if (newPaddingLen == 512) //remainder was 0
                {
                    newPaddingLen = 0;
                    //write stored half
                    bw.Write(mapHalf);
                }
                else //means remainder wasnt 0
                {
                    byte[] padding = new byte[newPaddingLen];
                    bw.Write(padding);
                    bw.Write(mapHalf);
                }

                shift += newPaddingLen - oldPaddingLen;

                //now map hlf is there, write size
                bw.BaseStream.Position = (map.tags.tagsList[0].MetaOffset + 400 + shift) + (28 * langIndx) + 4;
                bw.Write(ud.langs[langIndx].tableSize);

                if (shift != 0) //the padding hasnt realigned the rest of the map.. so we have to
                {
                    //--[Header]
                    bw.BaseStream.Position = 16;
                    bw.Write(map.header.indexOffset += shift);

                    map.header.metaStart += shift;

                    br.BaseStream.Position = 344;
                    bw.Write(map.header.strangeFileStringsOffset += shift);

                    //--[Index]
                    map.index.primaryMagic -= shift;
                    map.index.offsetOfObjectIndex += shift;
                    map.index.secondaryMagic -= shift;

                    //--[Unicode]
                    int matgOffset400 = map.tags.tagsList[0].MetaOffset + 400 + shift;
                    for (int x = langIndx + 1; x < 8; x++)
                    {
                        bw.BaseStream.Position = matgOffset400 + (28 * x) + 8;
                        ud.langs[x].indexPointerOffset = bw.BaseStream.Position;

                        bw.Write(ud.langs[x].indexOffset += shift);
                        bw.Write(ud.langs[x].tableOffset += shift);
                    }

                    //--[Bitmaps]
                    List<int> bitmTags = new List<int>();
                    for (int x = 0; x < map.tags.tagsList.Length; x++)
                    {
                        if (map.tags.tagsList[x].Type == "bitm")
                            bitmTags.Add(x);
                    }

                    for (int z = 0; z < bitmTags.Count; z++)
                    {
                        br.BaseStream.Position = map.tags.tagsList[bitmTags[z]].MetaOffset + 68 + shift;

                        int tempc = br.ReadInt32();
                        int tempr = br.ReadInt32() - map.index.secondaryMagic;

                        for (int x = 0; x < tempc; x++)
                        {
                            for (int y = 0; y < 6; y++)
                            {
                                int PointerOffset = tempr + (x * 116) + 28 + (y * 4);
                                br.BaseStream.Position = PointerOffset;

                                int Offset = br.ReadInt32();
                                if (Offset == -1) break;

                                RawLocations rawLoc = RawLocations.Internal;
                                map.rawData.ParseSPointer(ref Offset, ref rawLoc);

                                if (rawLoc == RawLocations.Internal)
                                {
                                    bw.BaseStream.Position = PointerOffset;
                                    bw.Write(Offset + shift);
                                }
                            }
                        }
                    }

                    //--[Meta Offsets]
                    for (int x = 0; x < map.tags.tagsList.Length; x++)
                    {
                        if (map.tags.tagsList[x].Type != "sbsp" && map.tags.tagsList[x].Type != "ltmp")
                            map.tags.tagsList[x].MetaOffset += shift;
                    }

                    //--[End]
                    bw.BaseStream.Position = map.tags.tagsList[map.tags.tagsList.Length - 1].MetaOffset +
                        map.tags.tagsList[map.tags.tagsList.Length - 1].MetaSize;

                    newPaddingLen = 512 - ((int)bw.BaseStream.Position % 512);
                    newPaddingLen += newPaddingLen == 512 ? 512 : 1024;

                    int eof = (int)bw.BaseStream.Position + newPaddingLen;

                    while (bw.BaseStream.Position < eof)
                        bw.Write((byte)205); //CD

                    bw.BaseStream.SetLength(eof);

                    //--[Header]
                    bw.BaseStream.Position = 8;
                    bw.Write(eof);
                }
                br.Close();
            }

            bw.Close();

            ud.langs[langIndx].UniStrings[strIndx].uString = newText;
            ud.langs[langIndx].UniStrings[strIndx].Length = txtBytes.Length;
            //map.rawData.rdh = ud; //not needed
        }
    }
}