using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Visual_Scenery_Mover
{
    public sealed class ClustersPVS
    {
        public static ClusterPVS[] GetClustersPVSInfo(ref Meta meta)
        {
            BinaryReader BR = new BinaryReader(meta.MS);
            BR.BaseStream.Position = 172;
            int clustercount = BR.ReadInt32();

            BR.BaseStream.Position = 100;
            int tempc = BR.ReadInt32();
            int tempr = BR.ReadInt32() - meta.magic - meta.offset;
            BR.BaseStream.Position = tempr;
            ClusterPVS[] tempclusters = new ClusterPVS[clustercount];

            for (int x = 0; x < clustercount; x++)
                tempclusters[x] = new ClusterPVS(ref BR, clustercount);

            return tempclusters;
        }
    }

    public class ClusterPVS
    {
        public List<int> FrontVisibleClusters = new List<int>();
        public List<int> BackVisibleClusters = new List<int>();
        public ClusterPVS(ref BinaryReader BR, int ClusterCount)
        {
            int bytecount = ClusterCount / 8;
            if (ClusterCount % 8 != 0) bytecount++;
            int paddedtobytecount = bytecount;
            if (paddedtobytecount % 4 != 0) paddedtobytecount += (paddedtobytecount % 4);
            int currcount = 0;
            while (currcount != -1)
            {
                byte temp = BR.ReadByte();
                bool done = false;
                for (int x = 0; x < 8; x++)
                {
                    byte tempbit = (byte)(temp & 0x80);
                    if (tempbit == (byte)0x80) FrontVisibleClusters.Add(ClusterCount - currcount - 1);
                    temp = (byte)(temp << 1);
                    currcount += 1;
                    if (currcount == ClusterCount)
                    {
                        done = true;
                        break;
                    }
                }
                if (done) break;
            }

            int difference = paddedtobytecount - bytecount;
            while (difference > 1)
            {
                BR.ReadByte();
                difference--;
            }

            currcount = 0;
            while (currcount != -1)
            {
                byte temp = BR.ReadByte();
                bool done = false;
                for (int x = 0; x < 8; x++)
                {
                    byte tempbit = (byte)(temp & 0x80);
                    if (tempbit == (byte)0x80) BackVisibleClusters.Add(ClusterCount - currcount - 1);
                    temp = (byte)(temp << 1);
                    currcount += 1;
                    if (currcount == ClusterCount)
                    {
                        done = true;
                        break;
                    }
                }
                if (done) break;
            }

            while (difference > 1)
            {
                BR.ReadByte();
                difference--;
            }
        }
    }
}
