using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Visual_Scenery_Mover
{
    public class SpawnInfo
    {
        public List<BaseSpawn> Spawn = new List<BaseSpawn>();

        public SpawnInfo(string mapLoc, Tags tag, Int32 secondaryMagic)
        {
            BinaryReader br = new BinaryReader(new FileStream(mapLoc,
              FileMode.Open, FileAccess.Read, FileShare.ReadWrite));

            //find default mc model
            br.BaseStream.Position =tag.tagInfo[0].MetaOffset + 308;
            int tempr = br.ReadInt32() - secondaryMagic;
            br.BaseStream.Position = tempr + 4;
            int tempbipdtag = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

            int bipdmodeltag = tag.FindModelByBaseClass(tempbipdtag, mapLoc);

            //Find objective models
            br.BaseStream.Position =tag.tagInfo[tag.FindByTagAndTagType("mulg", "multiplayer\\multiplayer_globals")].MetaOffset + 12;
            tempr = br.ReadInt32();
            int ctfmodeltag = -1;
            int ballmodeltag = -1;
            int juggernautdmodeltag = -1;
            int assultmodeltag = -1;
            if (tempr != 0)
            {
                tempr -= secondaryMagic;
                br.BaseStream.Position = tempr + 4;
                int tempCtftag = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                br.BaseStream.Position = tempr + 12;
                int tempBalltag = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                br.BaseStream.Position = tempr + 52;
                int tempJuggernauttag = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                br.BaseStream.Position = tempr + 60;
                int tempAssaulttag = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                ctfmodeltag = tag.FindModelByBaseClass(tempCtftag, mapLoc);
                ballmodeltag = tag.FindModelByBaseClass(tempBalltag, mapLoc);
                juggernautdmodeltag = tag.FindModelByBaseClass(tempJuggernauttag, mapLoc);
                assultmodeltag = tag.FindModelByBaseClass(tempAssaulttag, mapLoc);
            }

            //Player Spawns
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 256;
            int tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (52 * x);

                PlayerSpawn ps = new PlayerSpawn();
                ps.offset = tempr + (52 * x);
                ps.X = br.ReadSingle();
                ps.Y = br.ReadSingle();
                ps.Z = br.ReadSingle();
                ps.RotationDirection = br.ReadSingle();
                ps.ModelTagNumber = bipdmodeltag;
                ps.ModelName =tag.tagInfo[ps.ModelTagNumber].TagPath;
                Spawn.Add(ps);
            }

            //death zones
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 264;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (68 * x) + 36;

                DeathZone dz = new DeathZone();
                dz.offset = tempr + (68 * x) + 36;
                dz.X = br.ReadSingle();
                dz.Y = br.ReadSingle();
                dz.Z = br.ReadSingle();
                //   br.ReadSingle();
                dz.width = br.ReadSingle();
                dz.height = br.ReadSingle();
                dz.length = br.ReadSingle();

                float widthhalf = dz.length / 2;
                // ps.X = ps.X - widthhalf;
                widthhalf = dz.width / 2;

                dz.Y = dz.Y + widthhalf;

                widthhalf = dz.height / 2;
                dz.Z += dz.length / 2;
                //    MessageBox.Show("DeathZone");

                Spawn.Add(dz);
            }

            //lights

            //palette
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 240;
            int[] temppalette = new int[br.ReadInt32()];
            int[] temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                temppalette2[x] = tempbase;
                temppalette[x] = tempbase;
            }

            //placement
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 232;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (108 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (108 * x) + 8;
                LightSpawn vs = new LightSpawn();
                vs.offset = tempr + (108 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();

                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //objectives
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 280;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (32 * x);

                ObjectiveSpawn ps = new ObjectiveSpawn();
                ps.offset = tempr + (32 * x);
                ps.X = br.ReadSingle();
                ps.Y = br.ReadSingle();
                ps.Z = br.ReadSingle();
                ps.RotationDirection = br.ReadSingle();
                ps.ObjectiveType = (ObjectiveSpawn.ObjectiveTypeEnum)br.ReadInt16();
                ps.Team = (ObjectiveSpawn.TeamType)br.ReadInt16();
                ps.number = br.ReadInt16();

                if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.OddballSpawn && ballmodeltag != -1)
                    ps.ModelTagNumber = ballmodeltag;

                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.CTFRespawn && ctfmodeltag != -1)
                    ps.ModelTagNumber = ctfmodeltag;

                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.AssaultRespawn && assultmodeltag != -1)
                    ps.ModelTagNumber = assultmodeltag;

                else ps.ModelTagNumber = bipdmodeltag;

                ps.ModelName =tag.tagInfo[ps.ModelTagNumber].TagPath;
                Spawn.Add(ps);
            }

            //vehicles 
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 120;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 112;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (84 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (84 * x) + 8;
                VehicleSpawn vs = new VehicleSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //equipment
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 136;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 128;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (56 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (56 * x) + 8;
                EquipmentSpawn vs = new EquipmentSpawn();
                vs.offset = tempr + (56 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.RotationDirection = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //bipeds
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 104;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 96;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (84 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (84 * x) + 8;
                BipedSpawn vs = new BipedSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.RotationDirection = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //control
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 192;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 184;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (68 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (68 * x) + 8;
                ControlSpawn vs = new ControlSpawn();
                vs.offset = tempr + (68 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.RotationDirection = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //machines
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 176;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 168;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (72 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (72 * x) + 8;
                MachineSpawn vs = new MachineSpawn();
                vs.offset = tempr + (72 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);

            }

            //scenery
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 88;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 80;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (92 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) { continue; }
                br.BaseStream.Position = tempr + (92 * x) + 8;
                ScenerySpawn vs = new ScenerySpawn();
                vs.offset = tempr + (92 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);

            }

            //weapons
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 152;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 144;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (84 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (84 * x) + 8;
                WeaponSpawn vs = new WeaponSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //obstacles
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 816;
            temppalette = new int[br.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = br.ReadInt32() - secondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                br.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);

                temppalette2[x] = tempbase;
                temppalette[x] = tag.FindModelByBaseClass(tempbase, mapLoc);
            }

            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 808;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                br.BaseStream.Position = tempr + (76 * x);
                short tempshort = br.ReadInt16();

                if (tempshort == -1) continue;
                br.BaseStream.Position = tempr + (76 * x) + 8;
                ObstacleSpawn vs = new ObstacleSpawn();
                vs.offset = tempr + (76 * x) + 8;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) continue;
                vs.TagPath =tag.tagInfo[temppalette2[tempshort]].TagPath;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //collections
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 288;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Collection vs = new Collection();
                br.BaseStream.Position = tempr + (144 * x) + 4;
                vs.SpawnsInMode = (Collection.SpawnsInEnum)br.ReadInt32();
                br.BaseStream.Position = tempr + (144 * x) + 64;
                vs.offset = tempr + (144 * x) + 64;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();

                //test
                //  if (vs.Pitch > 0) { vs.Pitch = -vs.Pitch; vs.isWeird = true; } else { vs.isWeird = false; }

                br.BaseStream.Position = tempr + (144 * x) + 92;
                int tempbase = Meta.FindMetaByID(br.ReadInt32(),tag.tagInfo);
                if (tempbase == -1)  continue; 

                vs.TagPath =tag.tagInfo[tempbase].TagPath;
                vs.ModelTagNumber = tag.FindModelByBaseClass(tempbase, mapLoc);
                if (vs.ModelTagNumber == -1) continue;
                vs.ModelName =tag.tagInfo[vs.ModelTagNumber].TagPath;
                Spawn.Add(vs);
            }

            //cameras
            br.BaseStream.Position =tag.tagInfo[3].MetaOffset + 488;
            tempc = br.ReadInt32();
            tempr = br.ReadInt32() - secondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                CameraSpawn vs = new CameraSpawn();
                br.BaseStream.Position = tempr + (64 * x) + 36;
                vs.offset = tempr + (64 * x) + 36;
                vs.X = br.ReadSingle();
                vs.Y = br.ReadSingle();
                vs.Z = br.ReadSingle();
                vs.Roll = br.ReadSingle();
                vs.Pitch = br.ReadSingle();
                vs.Yaw = br.ReadSingle();
                vs.fov = br.ReadSingle();
                vs.ModelTagNumber = -1;

                Spawn.Add(vs);
            }
            br.Close();
        }

        [FlagsAttribute]
        public enum SpawnType : int
        {
            Player = 1,
            Weapon = 2,
            Collection = 4,
            Vehicle = 8,
            Obstacle = 16,
            Machine = 32,
            Scenery = 64,
            Objective = 128,
            Equipment = 256,
            ItemCollection = 512,
            Biped = 1024,
            Control = 2048,
            Special = 4096,
            DeathZone = 8192,
            Camera = 16384,
            Light = 32768
        }

        public enum SpawnRotationType
        {
            Direction,
            YawPitchRoll
        }

        public class BoundingBoxSpawn : BaseSpawn
        {
            public float width;
            public float height;
            public float length;
        }

        public class BaseSpawn
        {
            public SpawnType Type;
            public string TagPath;
            public float X, Y, Z;

            public bool IsSelected;

            public int offset;
        }

        public class RotationSpawn : BaseSpawn
        {
            public int ModelTagNumber;
            public string ModelName;
            public SpawnRotationType RotationType;
        }

        public class RotateDirectionBaseSpawn : RotationSpawn
        {
            public float RotationDirection;
        }

        public class RotateYawPitchRollBaseSpawn : RotationSpawn
        {
            public Boolean isWeird;
            public float Yaw;
            public float Pitch;
            public float Roll;
        }

        public class PlayerSpawn : RotateDirectionBaseSpawn
        {
            public PlayerSpawn()
            {
                this.Type = SpawnType.Player;
                this.RotationType = SpawnRotationType.Direction;
            }
        }

        public class BipedSpawn : RotateDirectionBaseSpawn
        {
            public BipedSpawn()
            {
                this.Type = SpawnType.Biped;
                this.RotationType = SpawnRotationType.Direction;
            }
        }

        public class VehicleSpawn : RotateYawPitchRollBaseSpawn
        {
            public VehicleSpawn()
            {
                this.Type = SpawnType.Vehicle;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class CameraSpawn : RotateYawPitchRollBaseSpawn
        {
            public float fov;

            public CameraSpawn()
            {
                this.Type = SpawnType.Camera;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class LightSpawn : RotateYawPitchRollBaseSpawn
        {
            public HaloLight LightInfo;

            public LightSpawn()
            {
                this.Type = SpawnType.Light;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class ScenerySpawn : RotateYawPitchRollBaseSpawn
        {
            public ScenerySpawn()
            {
                this.Type = SpawnType.Scenery;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class WeaponSpawn : RotateYawPitchRollBaseSpawn
        {
            public WeaponSpawn()
            {
                this.Type = SpawnType.Weapon;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class EquipmentSpawn : RotateDirectionBaseSpawn
        {
            public EquipmentSpawn()
            {
                this.Type = SpawnType.Equipment;
                this.RotationType = SpawnRotationType.Direction;
            }
        }

        public class ControlSpawn : RotateDirectionBaseSpawn
        {
            public ControlSpawn()
            {
                this.Type = SpawnType.Control;
                this.RotationType = SpawnRotationType.Direction;
            }
        }

        public class SpecialSpawn : BoundingBoxSpawn
        {
            public string Name;
            public SpecialSpawnType specialSpawnType;
            public enum SpecialSpawnType
            {
                CTF,
                Initital
            }
            public SpecialSpawn()
            {
                this.Type = SpawnType.Special;

            }
        }

        public class DeathZone : BoundingBoxSpawn
        {
            public string Name;
            public DeathZone()
            {
                this.Type = SpawnType.DeathZone;

            }
        }

        public class MachineSpawn : RotateYawPitchRollBaseSpawn
        {
            public MachineSpawn()
            {
                this.Type = SpawnType.Machine;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class ObstacleSpawn : RotateYawPitchRollBaseSpawn
        {
            public ObstacleSpawn()
            {
                this.Type = SpawnType.Obstacle;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }

        public class Collection : RotateYawPitchRollBaseSpawn
        {
            public SpawnsInEnum SpawnsInMode;

            public Collection()
            {
                this.Type = SpawnType.Collection;
                this.RotationType = SpawnRotationType.YawPitchRoll;

            }
            public enum SpawnsInEnum
            {
                None = 0,
                CTFAndAssault = 1,
                Slayer = 2,
                Oddball = 3,
                KOTHOnly = 4,
                KOTHOnly2 = 5,
                KOTHOnly3 = 6,
                Juggernaut = 7,
                Territories = 8,
                CTFAndAssault2 = 9,
                KOTHOnly4 = 10,
                KOTHOnly5 = 11,
                All = 12,
                AllExceptCTFAndAssault = 13,
                AllExceptCTFAndAssault2 = 14
            }
        }

        public class ObjectiveSpawn : RotateDirectionBaseSpawn
        {
            public ObjectiveTypeEnum ObjectiveType;
            public TeamType Team;
            public short number;
            public ObjectiveSpawn()
            {
                this.Type = SpawnType.Objective;
                this.RotationType = SpawnRotationType.Direction;
            }
            public enum ObjectiveTypeEnum
            {
                CTFRespawn = 0,
                CTFScore = 1,
                AssaultRespawn = 2,
                ArmingCircle = 3,
                OddballSpawn = 4,
                TeleporterEntrance = 7,
                TeleporterExit = 8,
                Territory = 10,
                HillVertex1 = 11,
                HillVertex2 = 12,
                HillVertex3 = 13,
                HillVertex4 = 14,
                HillVertex5 = 15,
            }
            public enum TeamType
            {
                Defense = 0,
                Offense = 1,
                Neutral = 8
            }
        }
    }
}
