using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Visual_Scenery_Mover
{
    public class Header
    {
        public string internalName;

        //enum of different types of map
        public enum MapTypes
        {
            Internal,
            MainMenu,
            SPShared,
            MPShared
        }
        MapTypes mapType;

        public Int32
        indexOffset,
        indexSizeAndMetaStart,
        metaSize,
        nonRawSize,

        mapTypeInt,

        sizeOfStrangeFileStrings,
        offsetToStrangeFileStrings,

        offsetToScriptReference,
        scriptReferenceCount,
        sizeOfScriptReference,
        offsetOfScriptReferenceIndex,
        offsetOfScriptReferenceStrings,

        fileCount,
        fileTableOffset,
        fileTableSize,
        fileIndex,

        checksum;

        public Header(BinaryReader br)
        {
            br.BaseStream.Position = 16;

            //the offset of the index
            indexOffset = br.ReadInt32();

            //the total length in bytes of the index and the start of the meta
            indexSizeAndMetaStart = br.ReadInt32();

            //the total length in bytes of the meta
            metaSize = br.ReadInt32();
            nonRawSize = br.ReadInt32();

            br.BaseStream.Position = 320;

            //a number representing the type of the map
            mapTypeInt = br.ReadInt32();

            //1=norm 2=mm 3=shared 4=spshared
            mapType = (MapTypes)mapTypeInt;

            br.BaseStream.Position += 16;

            //the size and offset of the strange file strings
            sizeOfStrangeFileStrings = br.ReadInt32();
            offsetToStrangeFileStrings = br.ReadInt32();

            br.BaseStream.Position += 4;

            //script reference info
            offsetToScriptReference = 128 + br.ReadInt32();
            scriptReferenceCount = br.ReadInt32();
            sizeOfScriptReference = br.ReadInt32();
            offsetOfScriptReferenceIndex = br.ReadInt32();
            offsetOfScriptReferenceStrings = br.ReadInt32();

            br.BaseStream.Position += 36;

            char chr;
            //the internal name of the name
            while ((chr = br.ReadChar()) != '\0')
                internalName += chr;

            br.BaseStream.Position = 704;

            //file info
            fileCount = br.ReadInt32();
            fileTableOffset = br.ReadInt32();
            fileTableSize = br.ReadInt32();
            fileIndex = br.ReadInt32();

            //maps safecheck, its every byte after the header(2048bytes) xored
            checksum = br.ReadInt32();
        }
    }
}
