using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Visual_Scenery_Mover
{
    public class Unicode
    {
        public enum Language
        {
            English,
            Japanese,
            German,
            French,
            Spanish,
            Italian,
            Korean,
            Chinese,
            Portuguese
        }

        public struct Uni
        {
            public bool scanned;
            public Language language;
            public int count;
            public int tableSize;
            public int indexOffset;
            public int indexPointerOffset;
            public int tableOffset;
            public int tablePointerOffset;

            public IDSize[] idsiz;
            public UniString[] US;
        }

        public struct IDSize
        {
            public int id;
            public byte size;

            public IDSize(int iid, byte uselessByte, byte isize)
            {
                this.size = isize;
                this.id = iid;
            }
        }

        public struct UniString
        {
            public int offset, size;
            public string uString;

            public UniString(int ioffset)
            {
                this.offset = ioffset;
                this.size = 0;
                this.uString = "";
            }
        }

        public List<Uni> UnicodeStrings;

        public Unicode(BinaryReader br, int matgOffset)
        {
            UnicodeStrings = new List<Uni>();
            for (int x = 0; x < 9; x++)
            {
                br.BaseStream.Position = matgOffset + 400 + 28 * x;

                Uni un = new Uni();
                un.scanned = false;
                un.language = (Language)x;
                un.count = br.ReadInt32();
                un.tableSize = br.ReadInt32();
                un.indexPointerOffset = (int)br.BaseStream.Position - matgOffset;
                un.indexOffset = br.ReadInt32();
                un.tablePointerOffset = (int)br.BaseStream.Position - matgOffset;
                un.tableOffset = br.ReadInt32();

                //---Index and Table
                un.idsiz = new IDSize[un.count];
                un.US = new UniString[un.count];

                Encoding decode = Encoding.UTF8;

                for (int y = 0; y < un.count; y++)
                {
                    br.BaseStream.Position = un.indexOffset + (y * 8);

                    un.idsiz[y] = new IDSize(br.ReadInt16(), br.ReadByte(), br.ReadByte());
                    un.US[y] = new UniString(br.ReadInt32());

                    if (y != 0)
                    {
                        un.US[y - 1].size = un.US[y].offset - un.US[y - 1].offset - 1;
                        //MessageBox.Show(un.US[cnt - 1].size.ToString());
                        br.BaseStream.Position = un.tableOffset + un.US[y - 1].offset;
                        byte[] tmp1 = br.ReadBytes(un.US[y - 1].size);
                        un.US[y - 1].uString = decode.GetString(tmp1);
                    }
                }

                if (un.count - 1 > 0)
                {
                    un.US[un.count - 1].size = un.tableSize - un.US[un.count - 1].offset;

                    br.BaseStream.Position = un.tableOffset + un.US[un.count - 1].offset;
                    byte[] tmp2 = br.ReadBytes(un.US[un.count - 1].size);
                    un.US[un.count - 1].uString = decode.GetString(tmp2);

                    UnicodeStrings.Add(un);
                }
            }
        }
    }
}
