using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX;
using System.IO;

namespace Visual_Scenery_Mover
{
    public class FrameHierarchy
    {
        public List<FrameInfo> Frame = new List<FrameInfo>();

        public FrameHierarchy()
        {
        }

        public void GetFramesFromHalo2Model(ref Meta meta, int mapnum)
        {
            BinaryReader BR = new BinaryReader(meta.MS);

            BR.BaseStream.Position = 72;
            int tempc = BR.ReadInt32();
            int tempr = BR.ReadInt32() - meta.magic - meta.offset;
            for (int x = 0; x < tempc; x++)
            {
                FrameInfo inf = new FrameInfo();
                BR.BaseStream.Position = tempr + (96 * x);
                inf.Name = Map.mp[mapnum].strings.stringsList[BR.ReadUInt16()];
                BR.ReadUInt16();
                inf.Parent = BR.ReadInt16();
                inf.Child = BR.ReadInt16();
                inf.Sibling = BR.ReadInt16();
                BR.BaseStream.Position = tempr + (96 * x) + 12;
                inf.x = BR.ReadSingle();
                inf.y = BR.ReadSingle();
                inf.z = BR.ReadSingle();
                inf.i = BR.ReadSingle();
                inf.j = BR.ReadSingle();
                inf.k = BR.ReadSingle();
                inf.w = BR.ReadSingle();
                inf.matrix = Matrix.Identity;

                Quaternion q = new Quaternion(inf.i, inf.j, inf.k, inf.w);
                inf.matrix.Multiply(Matrix.Translation(inf.x, inf.y, inf.z));
                inf.matrix.RotateQuaternion(q);

                BR.ReadSingle();

                inf.skinweightmatrix = Matrix.Identity;
                inf.skinweightmatrix.M11 = BR.ReadSingle();
                inf.skinweightmatrix.M12 = BR.ReadSingle();
                inf.skinweightmatrix.M13 = BR.ReadSingle();
                inf.skinweightmatrix.M14 = 0.0f;

                inf.skinweightmatrix.M21 = BR.ReadSingle();
                inf.skinweightmatrix.M22 = BR.ReadSingle();
                inf.skinweightmatrix.M23 = BR.ReadSingle();
                inf.skinweightmatrix.M24 = 0.0f;

                inf.skinweightmatrix.M31 = BR.ReadSingle();
                inf.skinweightmatrix.M32 = BR.ReadSingle();
                inf.skinweightmatrix.M33 = BR.ReadSingle();
                inf.skinweightmatrix.M34 = 0.0f;

                inf.skinweightmatrix.M41 = BR.ReadSingle();
                inf.skinweightmatrix.M42 = BR.ReadSingle();
                inf.skinweightmatrix.M43 = BR.ReadSingle();
                inf.skinweightmatrix.M44 = 1.0f;

                inf.DistanceFromParent = BR.ReadSingle();
                // f.matrix.MultiplyTranspose(f.skinweightmatrix);//=Matrix.Transformation(new Vector3(0, 0, 0), new Quaternion(),new Vector3(1,1,1), new Vector3(0, 0, 0), q, new Vector3(f.x, f.y, f.z));
                Frame.Add(inf);
            }
        }
    }

    public class FrameInfo
    {
        public string Name;
        public Matrix matrix;
        public Matrix skinweightmatrix;
        public int Parent = -1;
        public int Child = -1;
        public int Sibling = -1;
        public float x, y, z;
        public float i, j, k, w;//quaternion

        public float DistanceFromParent;
    }
}
