using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Drawing;

using Microsoft.DirectX.Direct3D;
using Microsoft.DirectX;

namespace Visual_Scenery_Mover
{
    public class ShaderInfo
    {
        int levels = 1;
        public int tagnumber;
        public string shaderName;
        public Bitmap MainBitmap;
        public Texture MainTexture;
        public string MainName = "";
        public AlphaType Alpha;
        public Bitmap BumpMapBitmap;
        public Texture BumpMapTexture;
        public string BumpMapName;
        public Bitmap CubeMapBitmap;
        public Texture CubeMapTexture;
        public string CubeMapName;
        public Texture NormalMap;

        public Bitmap primarydetailBitmap;
        public Texture primarydetailTexture;
        public string primarydetailName;
        public float primarydetailuscale;
        public float primarydetailvscale;
        public float primarydetailwscale;
        public Bitmap secondarydetailBitmap;
        public Texture secondarydetailTexture;
        public string secondarydetailName;
        public float secondarydetailuscale;
        public float secondarydetailvscale;
        public float secondarydetailwscale;

        public Bitmap microdetailBitmap;
        public Texture microdetailTexture;
        public string microdetailName;
        public float microdetailuscale;
        public float microdetailvscale;
        public float microdetailwscale;
        public List<Bitmap> Bitmaps = new List<Bitmap>();
        public List<string> BitmapNames = new List<string>();
        public Texture[] BitmapTextures;

        public enum AlphaType
        {
            None,
            AlphaTest,
            AlphaBlend,
        }

        public ShaderInfo()
        {
        }

        public ShaderInfo(int tagnumber, int mapnum)
        {
            //open the Map.mp[mapnum].map in a reader
            BinaryReader br = new BinaryReader(new FileStream(Map.mp[mapnum].mapLoc,
                FileMode.Open, FileAccess.Read, FileShare.Read));

            this.tagnumber = tagnumber;
            if (this.tagnumber == -1) return;

            this.shaderName = Map.mp[mapnum].tags.tagInfo[tagnumber].TagPath;
            br.BaseStream.Position = Map.mp[mapnum].tags.tagInfo[this.tagnumber].MetaOffset + 4;

            int tempstem = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);
            if (tempstem != -1)
            {
                if (Map.mp[mapnum].tags.tagInfo[tempstem].TagPath.IndexOf("alphatest") != -1)
                    this.Alpha = ShaderInfo.AlphaType.AlphaTest;

                else if (Map.mp[mapnum].tags.tagInfo[tempstem].TagPath.IndexOf("alpha") != -1)
                    this.Alpha = ShaderInfo.AlphaType.AlphaBlend;

                else if (Map.mp[mapnum].tags.tagInfo[tempstem].TagPath.IndexOf("water") != -1)
                    this.Alpha = ShaderInfo.AlphaType.AlphaBlend;

                else this.Alpha = ShaderInfo.AlphaType.None;
            }
            else this.Alpha = ShaderInfo.AlphaType.None;

            br.BaseStream.Position = Map.mp[mapnum].tags.tagInfo[this.tagnumber].MetaOffset + 12;

            int tempc2 = br.ReadInt32();
            int tempr2 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;

            if (tempc2 != 0)
            {
                br.BaseStream.Position = tempr2 + 4;
                int tempcrap = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);

                if (tempcrap != -1)
                {
                    Meta tempmeta = new Meta(tempcrap);
                    tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                    ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);

                    this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                    this.MainName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                    this.levels = pm.Properties[0].mipMapCount;
                }

            }
            br.BaseStream.Position = Map.mp[mapnum].tags.tagInfo[this.tagnumber].MetaOffset + 32;
            tempc2 = br.ReadInt32();
            tempr2 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;

            br.BaseStream.Position = tempr2 + 24;
            int fuckr = br.ReadInt32();
            if (fuckr != 0)
            {
                fuckr -= Map.mp[mapnum].index.secondaryMagic;
                br.BaseStream.Position = fuckr;
                this.primarydetailuscale = br.ReadSingle();
                this.primarydetailvscale = br.ReadSingle();
                this.primarydetailwscale = br.ReadSingle();
                br.ReadSingle();
                this.secondarydetailuscale = br.ReadSingle();
                this.secondarydetailvscale = br.ReadSingle();
                this.secondarydetailwscale = br.ReadSingle();
            }
            br.BaseStream.Position = tempr2 + 4;
            tempc2 = br.ReadInt32();
            tempr2 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;

            if (tempc2 != 0)
            {
                br.BaseStream.Position = tempr2;
                int tempcrap = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);

                if (tempcrap != -1)
                {
                    int test = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath.IndexOf("reflection_maps");
                    if (Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath.IndexOf("_bump") != -1)
                    {
                        Meta tempmeta = new Meta(tempcrap);
                        tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                        ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                        this.BumpMapBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                        this.BumpMapName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                    }
                    else if (Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath.IndexOf("_cube_map") != -1)
                    {
                        Meta tempmeta = new Meta(tempcrap);
                        tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                        ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                        this.CubeMapBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                        this.CubeMapName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                    }
                    else if (Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath.IndexOf("default_") == -1 &&
                        this.MainBitmap == null && test == -1)
                    {
                        Meta tempmeta = new Meta(tempcrap);
                        tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                        ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                        this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                        this.MainName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                        this.levels = pm.Properties[0].mipMapCount;
                    }
                    else if (test != -1)
                    {

                        br.BaseStream.Position += 8;
                        tempcrap = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);
                        Meta tempmeta = new Meta(tempcrap);
                        tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                        ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                    }
                }

                br.BaseStream.Position = tempr2 + 24;
                tempcrap = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);
                if (tempcrap != -1 && this.MainBitmap == null)
                {
                    Meta tempmeta = new Meta(tempcrap);
                    tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                    ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                    this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                    this.MainName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                    this.levels = pm.Properties[0].mipMapCount;
                }
                else if (this.MainBitmap == null)
                {
                    br.BaseStream.Position = tempr2 + 12;
                    tempcrap = Meta.FindMetaByID(br.ReadInt32(), Map.mp[mapnum].tags.tagInfo);
                    if (tempcrap != -1)
                    {
                        Meta tempmeta = new Meta(tempcrap);
                        tempmeta.ReadMetaFromMap(false, true, false, mapnum);
                        ParsedBitmap pm = new ParsedBitmap(ref tempmeta, mapnum);
                        this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, 0, 0, mapnum);
                        this.MainName = Map.mp[mapnum].tags.tagInfo[tempcrap].TagPath;
                        this.levels = pm.Properties[0].mipMapCount;
                    }
                }
            }
            br.Close();
        }

        public void MakeTextures()
        {
            if (primarydetailBitmap != null)
                primarydetailTexture = CreateTexture(primarydetailBitmap);

            if (secondarydetailBitmap != null)
                secondarydetailTexture = CreateTexture(secondarydetailBitmap);

            if (microdetailBitmap != null)
                microdetailTexture = CreateTexture(microdetailBitmap);

            if (MainBitmap != null)
                MainTexture = CreateTexture(MainBitmap);
        }

        public void KillBitmaps()
        {
            BumpMapBitmap = null;
            CubeMapBitmap = null;
            MainBitmap = null;
        }

        public static Texture CreateTexture(Bitmap bitmap)
        {
            if (bitmap == null) return null;

            Texture texture = new Texture(Map.dev, bitmap.Width, bitmap.Height, 1, Usage.AutoGenerateMipMap,
                Format.A8R8G8B8, Pool.Managed);

            System.Drawing.Imaging.BitmapData bitmapData = bitmap.LockBits(
                new Rectangle(0, 0, bitmap.Width, bitmap.Height),

            System.Drawing.Imaging.ImageLockMode.ReadOnly, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            int pitch;
            GraphicsStream textureData = texture.LockRectangle(0, LockFlags.None, out pitch);

            unsafe
            {
                int* texturePointer = (int*)textureData.InternalDataPointer;
                for (int y = 0; y < bitmap.Height; y++)
                {
                    int* bitmapLinePointer = (int*)bitmapData.Scan0 + y * (bitmapData.Stride / sizeof(int));
                    int* textureLinePointer = texturePointer + y * (pitch / sizeof(int));
                    int length = bitmap.Width;
                    while (--length >= 0)
                        *textureLinePointer++ = *bitmapLinePointer++;
                }
            }

            bitmap.UnlockBits(bitmapData);
            texture.UnlockRectangle(0);
            texture.GenerateMipSubLevels();
            texture.AutoGenerateFilterType = TextureFilter.Linear;
            return texture;
        }
    }
}
