using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Visual_Scenery_Mover
{
    public class hlmtContainer
    {
        public int tagnumber;
        public PermutationInfo[] Permutations;

        public hlmtContainer(int tagnumberx, int mapnum)
        {
            //open the Map.mp[mapnum].map in a reader
            BinaryReader br = new BinaryReader(new FileStream(Map.mp[mapnum].mapLoc,
                FileMode.Open, FileAccess.Read, FileShare.Read));

            tagnumber = tagnumberx;
            br.BaseStream.Position = Map.mp[mapnum].tags.tagInfo[tagnumber].MetaOffset + 80;
            int tempc = br.ReadInt32();
            int tempr = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;
            Permutations = new PermutationInfo[tempc];
            for (int x = 0; x < tempc; x++)
            {
                Permutations[x] = new PermutationInfo();
                br.BaseStream.Position = tempr + (x * 56);
                Permutations[x].Name = Map.mp[mapnum].strings.stringsList[br.ReadInt16()];
                br.BaseStream.Position = tempr + (x * 56) + 20;
                int tempc2 = br.ReadInt32();
                int tempr2 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;
                Permutations[x].Piece = new PermutationInfo.PermutationPiece[tempc2];
                for (int xx = 0; xx < tempc2; xx++)
                {
                    Permutations[x].Piece[xx] = new PermutationInfo.PermutationPiece();
                    br.BaseStream.Position = tempr2 + (xx * 20);
                    string temps = Map.mp[mapnum].strings.stringsList[br.ReadInt16()];
                    Permutations[x].Piece[xx].PieceName = temps;
                    br.BaseStream.Position = tempr2 + (xx * 20) + 8;
                    int tempc3 = br.ReadInt32();
                    int tempr3 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;
                    Permutations[x].Piece[xx].Permutation = new PermutationInfo.PermutationPiece.PermutationVariation[tempc3];
                    for (int xxx = 0; xxx < tempc3; xxx++)
                    {
                        Permutations[x].Piece[xx].Permutation[xxx] = new PermutationInfo.PermutationPiece.PermutationVariation();
                        br.BaseStream.Position = tempr3 + (xxx * 32);
                        string temps2 = Map.mp[mapnum].strings.stringsList[br.ReadInt16()];
                        Permutations[x].Piece[xx].Permutation[xxx].PermutationNameX = temps2;
                        br.BaseStream.Position = tempr3 + (xxx * 32) + 12;
                        int tempc4 = br.ReadInt32();
                        int tempr4 = br.ReadInt32() - Map.mp[mapnum].index.secondaryMagic;
                    }
                }
            }
            br.Close();
        }

        public int FindPermutationByBaseClass(int tagnumber, int mapnum)
        {
            if (tagnumber == -1) { return -1; }
            int tempoff = 0;
            switch (Map.mp[mapnum].tags.tagInfo[tagnumber].TagType)
            {
                case "itmc":

                case "vehc":
                    tempoff = 24;
                    break;
                case "vehi":

                case "bloc":
                case "bipd":
                case "mach":
                case "scen":
                case "eqip":
                case "weap":
                    tempoff = 48;
                    break;
                default:
                    return -1;
            }

            //open the Map.mp[mapnum].map in a reader
            BinaryReader br = new BinaryReader(new FileStream(Map.mp[mapnum].mapLoc,
                FileMode.Open, FileAccess.Read, FileShare.Read));

            br.BaseStream.Position = Map.mp[mapnum].tags.tagInfo[tagnumber].MetaOffset + tempoff;
            string tempname = Map.mp[mapnum].strings.stringsList[br.ReadInt16()];

            return FindPermutation(tempname);
        }

        public int FindPermutation(string permutationName)
        {
            for (int x = 0; x < this.Permutations.Length; x++)
            {
                if (this.Permutations[x].Name == permutationName)
                {
                    return x;
                }
            }
            return 0;
        }

        public class PermutationInfo
        {
            public string Name;
            public PermutationPiece[] Piece;
            public class PermutationPiece
            {
                public string PieceName;
                public PermutationVariation[] Permutation;
                public class PermutationVariation
                {
                    public string PermutationNameX;
                }
            }
        }
    }
}
