using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Visual_Scenery_Mover
{
    public partial class PreferencesForm : Form
    {
        public PreferencesForm()
        {
            InitializeComponent();

            textBox1.Text = Pref.mainmenuLoc;
            textBox2.Text = Pref.MPSharedLoc;
            textBox3.Text = Pref.SPSharedLoc;
            checkBox1.Checked = Pref.activateTagsTabOnSelection;
            checkBox2.Checked = Pref.renderLightmap;
            checkBox3.Checked = Pref.renderSkybox;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            o.Title = "Select Mainmenu";
            o.FileName = "mainmenu.map";
            if (o.ShowDialog() == DialogResult.Cancel) return;
            textBox1.Text = o.FileName;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            o.Title = "Select Shared";
            o.FileName = "shared.map";
            if (o.ShowDialog() == DialogResult.Cancel) return;
            textBox2.Text = o.FileName;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            o.Title = "Select SP Shared";
            o.FileName = "single_player_shared.map";
            if (o.ShowDialog() == DialogResult.Cancel) return;
            textBox3.Text = o.FileName;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Pref.mainmenuLoc = textBox1.Text;
            Pref.MPSharedLoc = textBox2.Text;
            Pref.SPSharedLoc = textBox3.Text;
            Pref.activateTagsTabOnSelection = checkBox1.Checked;
            Pref.renderLightmap = checkBox2.Checked;
            Pref.renderSkybox = checkBox3.Checked;

            Pref.SavePreferences();
            this.Close();
        }
    }
}