using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX;

namespace Visual_Scenery_Mover
{
    public class Camera
    {
        private Plane[] m_frustum = new Plane[6];
        public float
        x = 0f,
        y = 3f,
        z = -5f,
        i = 0f,
        j = 0f,
        k = 0f;

        public Vector3
        Position,
        LookAt = new Vector3(0, 0, 0f),
        UpVector = new Vector3(0, 0, 1);

        public float
        radius = 1.0f,
        speed = 0.5f,
        radianh,
        radianv;
        public bool fixedrotation = false;
        public int oldx = 0, oldy = 0;

        public Camera()
        {
            radianh = radianv = 0.0f;
            Position = new Vector3(x, y, z);
            ComputePosition();
        }

        public void change(int x, int y)
        {
            int tempx = oldx - x;
            int tempy = oldy - y;

            radianh += DegreesToRadian((float)tempx);
            radianv += DegreesToRadian((float)tempy);

            ComputePosition();
            oldx = x;
            oldy = y;
        }

        public void AimCamera(Vector3 v)
        {
            i = v.X;
            j = v.Y;
            k = v.Z;
            LookAt.X = i;
            LookAt.Y = j;
            LookAt.Z = k;
        }
        public void ComputeStrafe(bool left)
        {
            // Keep all rotations between 0 and 2PI
            //radianh = radianh > (float)Math.PI * 2 ? radianh - (float)Math.PI * 2 : radianh;
            //radianh = radianh < 0 ? radianh + (float)Math.PI * 2 : radianh;

            //radianv = radianv > (float)Math.PI * 2 ? radianv - (float)Math.PI * 2 : radianv;
            //radianv = radianv < 0 ? radianv + (float)Math.PI * 2 : radianv;

            // Switch up-vector based on vertical rotation
            //UpVector = Position.X < 0 ? new Vector3(-1, 0, 1) : new Vector3(1, 0, 1);
            //radianv > Math.PI / 2 && radianv < Math.PI / 2 * 3 ?
            //new Vector3(0,  1,0) : new Vector3(0,  -1,0);

            float tempi = radius * (float)(Math.Cos(radianh - 1.57) * Math.Cos(radianv)) * this.speed;
            float tempj = radius * (float)(Math.Sin(radianh - 1.57) * Math.Cos(radianv)) * this.speed;

            if (left == true)
            {
                LookAt.X += tempi;
                LookAt.Y += tempj;

                x += tempi;
                y += tempj;

                Position.X = x;
                Position.Y = y;
            }
            else
            {
                LookAt.X -= tempi;
                LookAt.Y -= tempj;

                x -= tempi;
                y -= tempj;

                Position.X = x;
                Position.Y = y;
            }
        }

        public void ComputePosition()
        {
            // Keep all rotations between 0 and 2PI
            //radianh = radianh > (float)Math.PI * 2 ? radianh - (float)Math.PI * 2 : radianh;
            //radianh = radianh < 0 ? radianh + (float)Math.PI * 2 : radianh;

            //radianv = radianv > (float)Math.PI * 2 ? radianv - (float)Math.PI * 2 : radianv;
            //radianv = radianv < 0 ? radianv + (float)Math.PI * 2 : radianv;

            i = radius * (float)(Math.Cos(radianh) * Math.Cos(radianv));
            j = radius * (float)(Math.Sin(radianh) * Math.Cos(radianv));
            k = radius * (float)Math.Sin(radianv);

            if (fixedrotation)
            {
                Position.X = i + x;
                Position.Y = j + y;
                Position.Z = k + z;
            }
            else
            {
                LookAt.X = i + x;
                LookAt.Y = j + y;
                LookAt.Z = k + z;
            }
        }

        public float DegreesToRadian(float degree)
        {
            return (float)(degree * (Math.PI / 180));
        }
    }
}