using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX.Direct3D;
using System.Drawing;
using Microsoft.DirectX;

namespace Visual_Scenery_Mover
{
    class ModelRender
    {
        Material m1;
        public Camera cam;
        public ParsedModel pm;

        public void LoadModel(int mapnum)
        {
            pm = new ParsedModel(ref Map.mp[mapnum].meta, mapnum);

            ParsedModel.DisplayedInfo.LoadDirectXTexturesAndBuffers(ref pm);

            cam = new Camera();
            cam.speed = 0.01f;
            
            cam.x = 0.4296876f;
            cam.y = -0.1776272f;
            cam.z = 0.1536518f;
            cam.radianv = 6.03884f;
            cam.radianh = 2.687805f;

            cam.Position = new Vector3(cam.x, cam.y, cam.z);
            cam.ComputePosition();

            m1 = new Material();
            m1.Diffuse = Color.White;
            m1.Ambient = Color.White;
            m1.Specular = Color.White;

           Map.dev.RenderState.Lighting = true;
            SetUpCameraForModel();
        }

        public void SetUpCameraForModel()
        {
           Map.dev.Transform.World = Matrix.Identity;
           Map.dev.Transform.View = Matrix.LookAtRH(cam.Position, cam.LookAt, cam.UpVector);
           Map.dev.Transform.Projection = Matrix.PerspectiveFovRH((float)Math.PI / 4,
                1.0f, 0.1f, 10000.0f);
        }

        public void UpdateModelMatrices()
        {
           Map.dev.Transform.View = Matrix.LookAtRH(cam.Position, cam.LookAt, cam.UpVector);
        }

        public void Draw()
        {
           Map.dev.Transform.World = Matrix.Translation(0, 0, 0);
           Map.dev.Material = m1;
            ParsedModel.DisplayedInfo.DrawMeshes(pm, true);
        }
    }
}
